/* Driver template for the LEMON parser generator.
** The author disclaims copyright to this source code.
*/
/* First off, code is include which follows the "include" declaration
** in the input file. */
#include <stdio.h>
#line 12 "mdcTclParse.y"


#define _POSIX_SOURCE 1

#include <stddef.h>							/* NULL, size_t, and so on */
#include <malloc.h>
#include <tcl.h>
#include "general.h"
#include "TclListUtils.h"

extern int 
seshlex();

void 
yyerror(char *s);

#include <stdio.h>
#ifndef NULL
#define NULL 0
#endif

#ifndef TRUE
#define TRUE 1
#define FALSE 0
#endif

#define ParseTrace  Mdc2lst_ParseTrace
#define ParseTokenName  Mdc2lst_ParseTokenName
#define ParseAlloc  Mdc2lst_ParseAlloc
#define ParseFree  Mdc2lst_ParseFree
#define Parse  Mdc2lst_Parse

 
 struct MdcParseContext {
	 Tcl_Interp *interp;
	 Tcl_Obj *result;
 };

#line 47 "mdcTclParse.c"
/* Next is all token values, in a form suitable for use by makeheaders.
** This section will be null unless lemon is run with the -m switch.
*/
/* 
** These constants (all generated automatically by the parser generator)
** specify the various kinds of tokens (terminals) that the parser
** understands. 
**
** Each symbol here is a terminal symbol in the grammar.
*/
/* Make sure the INTERFACE macro is defined.
*/
#ifndef INTERFACE
# define INTERFACE 1
#endif
/* The next thing included is series of defines which control
** various aspects of the generated parser.
**    YYCODETYPE         is the data type used for storing terminal
**                       and nonterminal numbers.  "unsigned char" is
**                       used if there are fewer than 250 terminals
**                       and nonterminals.  "int" is used otherwise.
**    YYNOCODE           is a number of type YYCODETYPE which corresponds
**                       to no legal terminal or nonterminal number.  This
**                       number is used to fill in empty slots of the hash 
**                       table.
**    YYFALLBACK         If defined, this indicates that one or more tokens
**                       have fall-back values which should be used if the
**                       original value of the token will not parse.
**    YYACTIONTYPE       is the data type used for storing terminal
**                       and nonterminal numbers.  "unsigned char" is
**                       used if there are fewer than 250 rules and
**                       states combined.  "int" is used otherwise.
**    ParseTOKENTYPE     is the data type used for minor tokens given 
**                       directly to the parser from the tokenizer.
**    YYMINORTYPE        is the data type used for all minor tokens.
**                       This is typically a union of many types, one of
**                       which is ParseTOKENTYPE.  The entry in the union
**                       for base tokens is called "yy0".
**    YYSTACKDEPTH       is the maximum depth of the parser's stack.
**    ParseARG_SDECL     A static variable declaration for the %extra_argument
**    ParseARG_PDECL     A parameter declaration for the %extra_argument
**    ParseARG_STORE     Code to store %extra_argument into yypParser
**    ParseARG_FETCH     Code to extract %extra_argument from yypParser
**    YYNSTATE           the combined number of states.
**    YYNRULE            the number of rules in the grammar
**    YYERRORSYMBOL      is the code number of the error symbol.  If not
**                       defined, then do no error processing.
*/
/*  */
#define YYCODETYPE unsigned char
#define YYNOCODE 51
#define YYACTIONTYPE unsigned char
#define ParseTOKENTYPE Tcl_Obj *
typedef union {
  ParseTOKENTYPE yy0;
  int yy92;
  int yy101;
} YYMINORTYPE;
#define YYSTACKDEPTH 100
#define ParseARG_SDECL struct MdcParseContext *context;
#define ParseARG_PDECL ,struct MdcParseContext *context
#define ParseARG_FETCH struct MdcParseContext *context = yypParser->context
#define ParseARG_STORE yypParser->context = context
#define YYNSTATE 64
#define YYNRULE 52
#define YYERRORSYMBOL 29
#define YYERRSYMDT yy101
#define YY_NO_ACTION      (YYNSTATE+YYNRULE+2)
#define YY_ACCEPT_ACTION  (YYNSTATE+YYNRULE+1)
#define YY_ERROR_ACTION   (YYNSTATE+YYNRULE)
/* Next is the action table.  Each entry in this table contains
**
**  +  An integer which is the number representing the look-ahead
**     token
**
**  +  An integer indicating what action to take.  Number (N) between
**     0 and YYNSTATE-1 mean shift the look-ahead and go to state N.
**     Numbers between YYNSTATE and YYNSTATE+YYNRULE-1 mean reduce by
**     rule N-YYNSTATE.  Number YYNSTATE+YYNRULE means that a syntax
**     error has occurred.  Number YYNSTATE+YYNRULE+1 means the parser
**     accepts its input.
**
**  +  A pointer to the next entry with the same hash value.
**
** The action table is really a series of hash tables.  Each hash
** table contains a number of entries which is a power of two.  The
** "state" table (which follows) contains information about the starting
** point and size of each hash table.
*/
struct yyActionEntry {
  YYCODETYPE   lookahead;   /* The value of the look-ahead token */
  YYCODETYPE   next;        /* Next entry + 1. Zero at end of collision chain */
  YYACTIONTYPE action;      /* Action to take for this look-ahead */
};
typedef struct yyActionEntry yyActionEntry;
static const yyActionEntry yyActionTable[] = {
/* State 0 */
  {  44,   0,   1}, /*  1:        startingGarbage shift  1 */
  {  29,   0,  62}, /*  2:                  error shift  62 */
  {  38,   0, 117}, /*  3:                mdcfile accept */
  {  23,   0,  63}, /*  4:                WORDEND shift  63 */
/* State 1 */
  {  48,   0,   2}, /*  1:              textitems shift  2 */
/* State 2 */
  {   0,   0,  64}, /*  1:                      $ reduce 0 */
  {  16,   0,  51}, /*  2:              SEPARATOR shift  51 */
  {  41,   0,   3}, /*  3:           optSeparator shift  3 */
/* State 3 */
  {  26,   0,   6}, /*  1:              cartouche shift  6 */
  {   2,   0,  53}, /*  2:         BEGINCARTOUCHE shift  53 */
  {  28,   2,  21}, /*  3:            complexsign shift  21 */
  {   3,   0,  59}, /*  4:      BEGINOLDCARTOUCHE shift  59 */
  {  30,  14,  50}, /*  5:             hieroglyph shift  50 */
  {  31,  17,  38}, /*  6:            hieroglyphs shift  38 */
  {  32,   0,  35}, /*  7:    hieroglyphsOrSymbol shift  35 */
  {  33,   0,  24}, /*  8:             inhierlist shift  24 */
  {  34,   0,  18}, /*  9:            inhierlists shift  18 */
  {  35,   0,  49}, /* 10:              ligatures shift  49 */
  {  10,   0,  47}, /* 11:                GRAMMAR shift  47 */
  {  11,   0, 106}, /* 12:             HIEROGLYPH reduce 42 */
  {  12,   0,   7}, /* 13:                LINEEND shift  7 */
  {   4,   0,  22}, /* 14:              BEGINPHIL shift  22 */
  {  40,   0,  41}, /* 15:             optGrammar shift  41 */
  {  15,   0,   8}, /* 16:                PAGEEND shift  8 */
  {   5,   0,  27}, /* 17:                   BPAR shift  27 */
  {  19,   0,  48}, /* 18:                 SYMBOL shift  48 */
  {  20,   0,  11}, /* 19:                   TEXT shift  11 */
  {  45,  18,  23}, /* 20:              subcadrat shift  23 */
  {  46,  19,  15}, /* 21:             subcadrats shift  15 */
  {  47,  26,   4}, /* 22:               textitem shift  4 */
  {  22,   0,  10}, /* 23:                 TOGGLE shift  10 */
  {  49,   0,   5}, /* 24:              topcadrat shift  5 */
  {  24,   0,  12}, /* 25:                 cadrat shift  12 */
  {  21,   0,   9}, /* 26:              TEXTSUPER shift  9 */
/* State 12 */
  {  42,   0,  13}, /*  1:             optShading shift  13 */
  {  17,   0,  14}, /*  2:                SHADING shift  14 */
/* State 15 */
  {   6,   0,  16}, /*  1:                 COLUMN shift  16 */
/* State 16 */
  {  28,   0,  21}, /*  1:            complexsign shift  21 */
  {  31,   0,  38}, /*  2:            hieroglyphs shift  38 */
  {  30,   0,  50}, /*  3:             hieroglyph shift  50 */
  {  45,   2,  17}, /*  4:              subcadrat shift  17 */
  {  32,   9,  35}, /*  5:    hieroglyphsOrSymbol shift  35 */
  {  33,  10,  24}, /*  6:             inhierlist shift  24 */
  {  34,   0,  18}, /*  7:            inhierlists shift  18 */
  {  35,   0,  49}, /*  8:              ligatures shift  49 */
  {   4,   0,  22}, /*  9:              BEGINPHIL shift  22 */
  {  19,  14,  48}, /* 10:                 SYMBOL shift  48 */
  {  10,   0,  47}, /* 11:                GRAMMAR shift  47 */
  {  11,   0, 106}, /* 12:             HIEROGLYPH reduce 42 */
  {  40,   0,  41}, /* 13:             optGrammar shift  41 */
  {   5,   0,  27}, /* 14:                   BPAR shift  27 */
/* State 18 */
  {  18,   0,  19}, /*  1:                   STAR shift  19 */
/* State 19 */
  {  28,   2,  21}, /*  1:            complexsign shift  21 */
  {   4,   0,  22}, /*  2:              BEGINPHIL shift  22 */
  {  19,   0,  48}, /*  3:                 SYMBOL shift  48 */
  {  11,   0, 106}, /*  4:             HIEROGLYPH reduce 42 */
  {  40,   1,  41}, /*  5:             optGrammar shift  41 */
  {   5,   0,  27}, /*  6:                   BPAR shift  27 */
  {  30,   0,  50}, /*  7:             hieroglyph shift  50 */
  {  31,   3,  38}, /*  8:            hieroglyphs shift  38 */
  {  32,   0,  35}, /*  9:    hieroglyphsOrSymbol shift  35 */
  {  33,   0,  20}, /* 10:             inhierlist shift  20 */
  {  10,   0,  47}, /* 11:                GRAMMAR shift  47 */
  {  35,   4,  49}, /* 12:              ligatures shift  49 */
/* State 22 */
  {  40,   2,  41}, /*  1:             optGrammar shift  41 */
  {  20,   0,  34}, /*  2:                   TEXT shift  34 */
  {   4,   0,  22}, /*  3:              BEGINPHIL shift  22 */
  {  25,   8,  25}, /*  4:                cadrats shift  25 */
  {  24,   3,  33}, /*  5:                 cadrat shift  33 */
  {  45,   4,  23}, /*  6:              subcadrat shift  23 */
  {  46,   0,  15}, /*  7:             subcadrats shift  15 */
  {   5,   0,  27}, /*  8:                   BPAR shift  27 */
  {  28,   0,  21}, /*  9:            complexsign shift  21 */
  {  10,   0,  47}, /* 10:                GRAMMAR shift  47 */
  {  30,  10,  50}, /* 11:             hieroglyph shift  50 */
  {  31,  19,  38}, /* 12:            hieroglyphs shift  38 */
  {  32,   0,  35}, /* 13:    hieroglyphsOrSymbol shift  35 */
  {  33,   0,  24}, /* 14:             inhierlist shift  24 */
  {  34,   0,  18}, /* 15:            inhierlists shift  18 */
  {  35,   0,  49}, /* 16:              ligatures shift  49 */
  {  36,   0,  52}, /* 17:             maincadrat shift  52 */
  {  37,   0,  30}, /* 18:            maincadrats shift  30 */
  {  11,   0, 106}, /* 19:             HIEROGLYPH reduce 42 */
  {  19,   0,  48}, /* 20:                 SYMBOL shift  48 */
/* State 25 */
  {   8,   0,  26}, /*  1:                ENDPHIL shift  26 */
/* State 27 */
  {  40,   2,  41}, /*  1:             optGrammar shift  41 */
  {  20,   0,  34}, /*  2:                   TEXT shift  34 */
  {   4,   0,  22}, /*  3:              BEGINPHIL shift  22 */
  {  25,   8,  28}, /*  4:                cadrats shift  28 */
  {  24,   3,  33}, /*  5:                 cadrat shift  33 */
  {  45,   4,  23}, /*  6:              subcadrat shift  23 */
  {  46,   0,  15}, /*  7:             subcadrats shift  15 */
  {   5,   0,  27}, /*  8:                   BPAR shift  27 */
  {  28,   0,  21}, /*  9:            complexsign shift  21 */
  {  10,   0,  47}, /* 10:                GRAMMAR shift  47 */
  {  30,  10,  50}, /* 11:             hieroglyph shift  50 */
  {  31,  19,  38}, /* 12:            hieroglyphs shift  38 */
  {  32,   0,  35}, /* 13:    hieroglyphsOrSymbol shift  35 */
  {  33,   0,  24}, /* 14:             inhierlist shift  24 */
  {  34,   0,  18}, /* 15:            inhierlists shift  18 */
  {  35,   0,  49}, /* 16:              ligatures shift  49 */
  {  36,   0,  52}, /* 17:             maincadrat shift  52 */
  {  37,   0,  30}, /* 18:            maincadrats shift  30 */
  {  11,   0, 106}, /* 19:             HIEROGLYPH reduce 42 */
  {  19,   0,  48}, /* 20:                 SYMBOL shift  48 */
/* State 28 */
  {   9,   0,  29}, /*  1:                   EPAR shift  29 */
/* State 30 */
  {  16,   3,  51}, /*  1:              SEPARATOR shift  51 */
  {  41,   4,  31}, /*  2:           optSeparator shift  31 */
  {   8,   0,  89}, /*  3:                ENDPHIL reduce 25 */
  {   9,   0,  89}, /*  4:                   EPAR reduce 25 */
/* State 31 */
  {  36,   0,  32}, /*  1:             maincadrat shift  32 */
  {  19,   0,  48}, /*  2:                 SYMBOL shift  48 */
  {  20,   0,  34}, /*  3:                   TEXT shift  34 */
  {   4,   0,  22}, /*  4:              BEGINPHIL shift  22 */
  {  40,   4,  41}, /*  5:             optGrammar shift  41 */
  {   5,   0,  27}, /*  6:                   BPAR shift  27 */
  {  24,   0,  33}, /*  7:                 cadrat shift  33 */
  {  28,   9,  21}, /*  8:            complexsign shift  21 */
  {  10,   0,  47}, /*  9:                GRAMMAR shift  47 */
  {  45,   0,  23}, /* 10:              subcadrat shift  23 */
  {  46,   8,  15}, /* 11:             subcadrats shift  15 */
  {  11,   0, 106}, /* 12:             HIEROGLYPH reduce 42 */
  {  30,   0,  50}, /* 13:             hieroglyph shift  50 */
  {  31,   0,  38}, /* 14:            hieroglyphs shift  38 */
  {  32,   0,  35}, /* 15:    hieroglyphsOrSymbol shift  35 */
  {  33,   0,  24}, /* 16:             inhierlist shift  24 */
  {  34,   0,  18}, /* 17:            inhierlists shift  18 */
  {  35,   0,  49}, /* 18:              ligatures shift  49 */
/* State 35 */
  {  14,   0,  36}, /*  1:              OVERWRITE shift  36 */
/* State 36 */
  {  40,   2,  41}, /*  1:             optGrammar shift  41 */
  {  32,   0,  37}, /*  2:    hieroglyphsOrSymbol shift  37 */
  {  10,   0,  47}, /*  3:                GRAMMAR shift  47 */
  {  35,   5,  49}, /*  4:              ligatures shift  49 */
  {  19,   6,  48}, /*  5:                 SYMBOL shift  48 */
  {  11,   0, 106}, /*  6:             HIEROGLYPH reduce 42 */
  {  30,   0,  50}, /*  7:             hieroglyph shift  50 */
  {  31,   0,  38}, /*  8:            hieroglyphs shift  38 */
/* State 38 */
  {   1,   0,  39}, /*  1:                    AMP shift  39 */
/* State 39 */
  {  40,   0,  41}, /*  1:             optGrammar shift  41 */
  {  10,   0,  47}, /*  2:                GRAMMAR shift  47 */
  {  30,   2,  40}, /*  3:             hieroglyph shift  40 */
  {  11,   0, 106}, /*  4:             HIEROGLYPH reduce 42 */
/* State 41 */
  {  11,   0,  42}, /*  1:             HIEROGLYPH shift  42 */
/* State 42 */
  {  39,   0,  43}, /*  1:              modifiers shift  43 */
/* State 43 */
  {  13,   0,  46}, /*  1:               MODIFIER shift  46 */
  {  43,   1,  44}, /*  2:             optWordEnd shift  44 */
  {  23,   0,  45}, /*  3:                WORDEND shift  45 */
/* State 47 */
  {  11,   0, 107}, /*  1:             HIEROGLYPH reduce 43 */
/* State 53 */
  {  27,   0,  54}, /*  1:         cartoucheTexts shift  54 */
/* State 54 */
  {  40,   2,  41}, /*  1:             optGrammar shift  41 */
  {  20,   0,  57}, /*  2:                   TEXT shift  57 */
  {  22,   0,  58}, /*  3:                 TOGGLE shift  58 */
  {   4,   0,  22}, /*  4:              BEGINPHIL shift  22 */
  {  24,   4,  12}, /*  5:                 cadrat shift  12 */
  {  45,  17,  23}, /*  6:              subcadrat shift  23 */
  {  46,   0,  15}, /*  7:             subcadrats shift  15 */
  {   7,   0,  55}, /*  8:           ENDCARTOUCHE shift  55 */
  {  28,   0,  21}, /*  9:            complexsign shift  21 */
  {  49,   0,  56}, /* 10:              topcadrat shift  56 */
  {  30,  18,  50}, /* 11:             hieroglyph shift  50 */
  {  31,  19,  38}, /* 12:            hieroglyphs shift  38 */
  {  32,   0,  35}, /* 13:    hieroglyphsOrSymbol shift  35 */
  {  33,   0,  24}, /* 14:             inhierlist shift  24 */
  {  34,   0,  18}, /* 15:            inhierlists shift  18 */
  {  35,   0,  49}, /* 16:              ligatures shift  49 */
  {   5,   0,  27}, /* 17:                   BPAR shift  27 */
  {  10,   0,  47}, /* 18:                GRAMMAR shift  47 */
  {  11,   0, 106}, /* 19:             HIEROGLYPH reduce 42 */
  {  19,   0,  48}, /* 20:                 SYMBOL shift  48 */
/* State 59 */
  {  27,   0,  60}, /*  1:         cartoucheTexts shift  60 */
/* State 60 */
  {  40,   2,  41}, /*  1:             optGrammar shift  41 */
  {  20,   0,  57}, /*  2:                   TEXT shift  57 */
  {  22,   0,  58}, /*  3:                 TOGGLE shift  58 */
  {   4,   0,  22}, /*  4:              BEGINPHIL shift  22 */
  {  24,   4,  12}, /*  5:                 cadrat shift  12 */
  {  45,  17,  23}, /*  6:              subcadrat shift  23 */
  {  46,   0,  15}, /*  7:             subcadrats shift  15 */
  {   7,   0,  61}, /*  8:           ENDCARTOUCHE shift  61 */
  {  28,   0,  21}, /*  9:            complexsign shift  21 */
  {  49,   0,  56}, /* 10:              topcadrat shift  56 */
  {  30,  18,  50}, /* 11:             hieroglyph shift  50 */
  {  31,  19,  38}, /* 12:            hieroglyphs shift  38 */
  {  32,   0,  35}, /* 13:    hieroglyphsOrSymbol shift  35 */
  {  33,   0,  24}, /* 14:             inhierlist shift  24 */
  {  34,   0,  18}, /* 15:            inhierlists shift  18 */
  {  35,   0,  49}, /* 16:              ligatures shift  49 */
  {   5,   0,  27}, /* 17:                   BPAR shift  27 */
  {  10,   0,  47}, /* 18:                GRAMMAR shift  47 */
  {  11,   0, 106}, /* 19:             HIEROGLYPH reduce 42 */
  {  19,   0,  48}, /* 20:                 SYMBOL shift  48 */
/* State 62 */
  {   0,   0,  65}, /*  1:                      $ reduce 1 */
};

/* The state table contains information needed to look up the correct
** action in the action table, given the current state of the parser.
** Information needed includes:
**
**  +  A pointer to the start of the action hash table in yyActionTable.
**
**  +  The number of entries in the action hash table.
**
**  +  The default action.  This is the action to take if no entry for
**     the given look-ahead is found in the action hash table.
*/
struct yyStateEntry {
  const yyActionEntry *hashtbl;  /* Start of the hash table in yyActionTable */
  YYCODETYPE nEntry;             /* Number of entries in action hash table */
  YYACTIONTYPE actionDefault;    /* Default action if look-ahead not found */
};
typedef struct yyStateEntry yyStateEntry;
static const yyStateEntry yyStateTable[] = {
  { &yyActionTable[0],   4,  67 },
  { &yyActionTable[4],   1,  68 },
  { &yyActionTable[5],   3,  92 },
  { &yyActionTable[8],  26, 116 },
  { &yyActionTable[34],   0,  69 },
  { &yyActionTable[34],   0,  70 },
  { &yyActionTable[34],   0,  71 },
  { &yyActionTable[34],   0,  72 },
  { &yyActionTable[34],   0,  73 },
  { &yyActionTable[34],   0,  74 },
  { &yyActionTable[34],   0,  75 },
  { &yyActionTable[34],   0,  76 },
  { &yyActionTable[34],   2,  78 },
  { &yyActionTable[36],   0,  77 },
  { &yyActionTable[36],   0,  79 },
  { &yyActionTable[36],   1,  80 },
  { &yyActionTable[37],  14, 116 },
  { &yyActionTable[51],   0,  82 },
  { &yyActionTable[51],   1,  83 },
  { &yyActionTable[52],  12, 116 },
  { &yyActionTable[64],   0,  85 },
  { &yyActionTable[64],   0,  86 },
  { &yyActionTable[64],  20, 116 },
  { &yyActionTable[84],   0,  81 },
  { &yyActionTable[84],   0,  84 },
  { &yyActionTable[84],   1, 116 },
  { &yyActionTable[85],   0,  87 },
  { &yyActionTable[85],  20, 116 },
  { &yyActionTable[105],   1, 116 },
  { &yyActionTable[106],   0,  88 },
  { &yyActionTable[106],   4,  92 },
  { &yyActionTable[110],  18, 116 },
  { &yyActionTable[128],   0,  91 },
  { &yyActionTable[128],   0,  94 },
  { &yyActionTable[128],   0,  95 },
  { &yyActionTable[128],   1,  96 },
  { &yyActionTable[129],   8, 116 },
  { &yyActionTable[137],   0,  97 },
  { &yyActionTable[137],   1,  98 },
  { &yyActionTable[138],   4, 116 },
  { &yyActionTable[142],   0, 102 },
  { &yyActionTable[142],   1, 116 },
  { &yyActionTable[143],   1, 108 },
  { &yyActionTable[144],   3, 104 },
  { &yyActionTable[147],   0, 103 },
  { &yyActionTable[147],   0, 105 },
  { &yyActionTable[147],   0, 109 },
  { &yyActionTable[147],   1, 116 },
  { &yyActionTable[148],   0,  99 },
  { &yyActionTable[148],   0, 100 },
  { &yyActionTable[148],   0, 101 },
  { &yyActionTable[148],   0,  93 },
  { &yyActionTable[148],   0,  90 },
  { &yyActionTable[148],   1, 112 },
  { &yyActionTable[149],  20, 116 },
  { &yyActionTable[169],   0, 110 },
  { &yyActionTable[169],   0, 113 },
  { &yyActionTable[169],   0, 114 },
  { &yyActionTable[169],   0, 115 },
  { &yyActionTable[169],   1, 112 },
  { &yyActionTable[170],  20, 116 },
  { &yyActionTable[190],   0, 111 },
  { &yyActionTable[190],   1, 116 },
  { &yyActionTable[191],   0,  66 },
};

/* The next table maps tokens into fallback tokens.  If a construct
** like the following:
** 
**      %fallback ID X Y Z.
**
** appears in the grammer, then ID becomes a fallback token for X, Y,
** and Z.  Whenever one of the tokens X, Y, or Z is input to the parser
** but it does not parse, the type of the token is changed to ID and
** the parse is retried before an error is thrown.
*/
#ifdef YYFALLBACK
static const YYCODETYPE yyFallback[] = {
};
#endif /* YYFALLBACK */

/* The following structure represents a single element of the
** parser's stack.  Information stored includes:
**
**   +  The state number for the parser at this level of the stack.
**
**   +  The value of the token stored at this level of the stack.
**      (In other words, the "major" token.)
**
**   +  The semantic value stored at this level of the stack.  This is
**      the information used by the action routines in the grammar.
**      It is sometimes called the "minor" token.
*/
struct yyStackEntry {
  int stateno;       /* The state-number */
  int major;         /* The major token value.  This is the code
                     ** number for the token at this stack level */
  YYMINORTYPE minor; /* The user-supplied minor token value.  This
                     ** is the value of the token  */
};
typedef struct yyStackEntry yyStackEntry;

/* The state of the parser is completely contained in an instance of
** the following structure */
struct yyParser {
  int yyidx;                    /* Index of top element in stack */
  int yyerrcnt;                 /* Shifts left before out of the error */
  yyStackEntry *yytop;          /* Pointer to the top stack element */
  ParseARG_SDECL                /* A place to hold %extra_argument */
  yyStackEntry yystack[YYSTACKDEPTH];  /* The parser's stack */
};
typedef struct yyParser yyParser;

#ifndef NDEBUG
#include <stdio.h>
static FILE *yyTraceFILE = 0;
static char *yyTracePrompt = 0;
#endif /* NDEBUG */

#ifndef NDEBUG
/* 
** Turn parser tracing on by giving a stream to which to write the trace
** and a prompt to preface each trace message.  Tracing is turned off
** by making either argument NULL 
**
** Inputs:
** <ul>
** <li> A FILE* to which trace output should be written.
**      If NULL, then tracing is turned off.
** <li> A prefix string written at the beginning of every
**      line of trace output.  If NULL, then tracing is
**      turned off.
** </ul>
**
** Outputs:
** None.
*/
void ParseTrace(FILE *TraceFILE, char *zTracePrompt){
  yyTraceFILE = TraceFILE;
  yyTracePrompt = zTracePrompt;
  if( yyTraceFILE==0 ) yyTracePrompt = 0;
  else if( yyTracePrompt==0 ) yyTraceFILE = 0;
}
#endif /* NDEBUG */

#ifndef NDEBUG
/* For tracing shifts, the names of all terminals and nonterminals
** are required.  The following table supplies these names */
static const char *yyTokenName[] = { 
  "$",             "AMP",           "BEGINCARTOUCHE",  "BEGINOLDCARTOUCHE",
  "BEGINPHIL",     "BPAR",          "COLUMN",        "ENDCARTOUCHE",
  "ENDPHIL",       "EPAR",          "GRAMMAR",       "HIEROGLYPH",  
  "LINEEND",       "MODIFIER",      "OVERWRITE",     "PAGEEND",     
  "SEPARATOR",     "SHADING",       "STAR",          "SYMBOL",      
  "TEXT",          "TEXTSUPER",     "TOGGLE",        "WORDEND",     
  "cadrat",        "cadrats",       "cartouche",     "cartoucheTexts",
  "complexsign",   "error",         "hieroglyph",    "hieroglyphs", 
  "hieroglyphsOrSymbol",  "inhierlist",    "inhierlists",   "ligatures",   
  "maincadrat",    "maincadrats",   "mdcfile",       "modifiers",   
  "optGrammar",    "optSeparator",  "optShading",    "optWordEnd",  
  "startingGarbage",  "subcadrat",     "subcadrats",    "textitem",    
  "textitems",     "topcadrat",   
};
#endif /* NDEBUG */

#ifndef NDEBUG
/* For tracing reduce actions, the names of all rules are required.
*/
static const char *yyRuleName[] = {
 /*   0 */ "mdcfile ::= startingGarbage textitems",
 /*   1 */ "mdcfile ::= error",
 /*   2 */ "startingGarbage ::= WORDEND",
 /*   3 */ "startingGarbage ::=",
 /*   4 */ "textitems ::=",
 /*   5 */ "textitems ::= textitems optSeparator textitem",
 /*   6 */ "textitem ::= topcadrat",
 /*   7 */ "textitem ::= cartouche",
 /*   8 */ "textitem ::= LINEEND",
 /*   9 */ "textitem ::= PAGEEND",
 /*  10 */ "textitem ::= TEXTSUPER",
 /*  11 */ "textitem ::= TOGGLE",
 /*  12 */ "textitem ::= TEXT",
 /*  13 */ "topcadrat ::= cadrat optShading",
 /*  14 */ "optShading ::=",
 /*  15 */ "optShading ::= SHADING",
 /*  16 */ "cadrat ::= subcadrats",
 /*  17 */ "subcadrats ::= subcadrat",
 /*  18 */ "subcadrats ::= subcadrats COLUMN subcadrat",
 /*  19 */ "subcadrat ::= inhierlists",
 /*  20 */ "inhierlists ::= inhierlist",
 /*  21 */ "inhierlists ::= inhierlists STAR inhierlist",
 /*  22 */ "inhierlist ::= complexsign",
 /*  23 */ "inhierlist ::= BEGINPHIL cadrats ENDPHIL",
 /*  24 */ "inhierlist ::= BPAR cadrats EPAR",
 /*  25 */ "cadrats ::= maincadrats",
 /*  26 */ "maincadrats ::= maincadrat",
 /*  27 */ "maincadrats ::= maincadrats optSeparator maincadrat",
 /*  28 */ "optSeparator ::=",
 /*  29 */ "optSeparator ::= SEPARATOR",
 /*  30 */ "maincadrat ::= cadrat",
 /*  31 */ "maincadrat ::= TEXT",
 /*  32 */ "complexsign ::= hieroglyphsOrSymbol",
 /*  33 */ "complexsign ::= hieroglyphsOrSymbol OVERWRITE hieroglyphsOrSymbol",
 /*  34 */ "hieroglyphsOrSymbol ::= hieroglyphs",
 /*  35 */ "hieroglyphsOrSymbol ::= SYMBOL",
 /*  36 */ "hieroglyphs ::= ligatures",
 /*  37 */ "ligatures ::= hieroglyph",
 /*  38 */ "ligatures ::= hieroglyphs AMP hieroglyph",
 /*  39 */ "hieroglyph ::= optGrammar HIEROGLYPH modifiers optWordEnd",
 /*  40 */ "optWordEnd ::=",
 /*  41 */ "optWordEnd ::= WORDEND",
 /*  42 */ "optGrammar ::=",
 /*  43 */ "optGrammar ::= GRAMMAR",
 /*  44 */ "modifiers ::=",
 /*  45 */ "modifiers ::= modifiers MODIFIER",
 /*  46 */ "cartouche ::= BEGINCARTOUCHE cartoucheTexts ENDCARTOUCHE",
 /*  47 */ "cartouche ::= BEGINOLDCARTOUCHE cartoucheTexts ENDCARTOUCHE",
 /*  48 */ "cartoucheTexts ::=",
 /*  49 */ "cartoucheTexts ::= cartoucheTexts topcadrat",
 /*  50 */ "cartoucheTexts ::= cartoucheTexts TEXT",
 /*  51 */ "cartoucheTexts ::= cartoucheTexts TOGGLE",
};
#endif /* NDEBUG */

/*
** This function returns the symbolic name associated with a token
** value.
*/
const char *ParseTokenName(int tokenType){
#ifndef NDEBUG
  if( tokenType>0 && tokenType<(sizeof(yyTokenName)/sizeof(yyTokenName[0])) ){
    return yyTokenName[tokenType];
  }else{
    return "Unknown";
  }
#else
  return "";
#endif
}

/* 
** This function allocates a new parser.
** The only argument is a pointer to a function which works like
** malloc.
**
** Inputs:
** A pointer to the function used to allocate memory.
**
** Outputs:
** A pointer to a parser.  This pointer is used in subsequent calls
** to Parse and ParseFree.
*/
void *ParseAlloc(void *(*mallocProc)(size_t)){
  yyParser *pParser;
  pParser = (yyParser*)(*mallocProc)( (size_t)sizeof(yyParser) );
  if( pParser ){
    pParser->yyidx = -1;
  }
  return pParser;
}

/* The following function deletes the value associated with a
** symbol.  The symbol can be either a terminal or nonterminal.
** "yymajor" is the symbol code, and "yypminor" is a pointer to
** the value.
*/
static void yy_destructor(YYCODETYPE yymajor, YYMINORTYPE *yypminor){
  switch( yymajor ){
    /* Here is inserted the actions which take place when a
    ** terminal or non-terminal is destroyed.  This can happen
    ** when the symbol is popped from the stack during a
    ** reduce or during error processing or when a parser is 
    ** being destroyed before it is finished parsing.
    **
    ** Note: during a reduce, the only symbols destroyed are those
    ** which appear on the RHS of the rule, but which are not used
    ** inside the C code.
    */
    default:  break;   /* If no destructor action specified: do nothing */
  }
}

/*
** Pop the parser's stack once.
**
** If there is a destructor routine associated with the token which
** is popped from the stack, then call it.
**
** Return the major token number for the symbol popped.
*/
static int yy_pop_parser_stack(yyParser *pParser){
  YYCODETYPE yymajor;

  if( pParser->yyidx<0 ) return 0;
#ifndef NDEBUG
  if( yyTraceFILE && pParser->yyidx>=0 ){
    fprintf(yyTraceFILE,"%sPopping %s\n",
      yyTracePrompt,
      yyTokenName[pParser->yytop->major]);
  }
#endif
  yymajor = pParser->yytop->major;
  yy_destructor( yymajor, &pParser->yytop->minor);
  pParser->yyidx--;
  pParser->yytop--;
  return yymajor;
}

/* 
** Deallocate and destroy a parser.  Destructors are all called for
** all stack elements before shutting the parser down.
**
** Inputs:
** <ul>
** <li>  A pointer to the parser.  This should be a pointer
**       obtained from ParseAlloc.
** <li>  A pointer to a function used to reclaim memory obtained
**       from malloc.
** </ul>
*/
void ParseFree(
  void *p,                    /* The parser to be deleted */
  void (*freeProc)(void*)     /* Function used to reclaim memory */
){
  yyParser *pParser = (yyParser*)p;
  if( pParser==0 ) return;
  while( pParser->yyidx>=0 ) yy_pop_parser_stack(pParser);
  (*freeProc)((void*)pParser);
}

/*
** Find the appropriate action for a parser given the look-ahead token.
**
** If the look-ahead token is YYNOCODE, then check to see if the action is
** independent of the look-ahead.  If it is, return the action, otherwise
** return YY_NO_ACTION.
*/
static int yy_find_parser_action(
  yyParser *pParser,        /* The parser */
  int iLookAhead             /* The look-ahead token */
){
  const yyStateEntry *pState;   /* Appropriate entry in the state table */
  const yyActionEntry *pAction; /* Action appropriate for the look-ahead */
  int iFallback;                /* Fallback token */
 
  /* if( pParser->yyidx<0 ) return YY_NO_ACTION;  */
  pState = &yyStateTable[pParser->yytop->stateno];
  if( pState->nEntry==0 ){
    return pState->actionDefault;
  }else if( iLookAhead!=YYNOCODE ){
    pAction = &pState->hashtbl[iLookAhead % pState->nEntry];
    while( 1 ){
      if( pAction->lookahead==iLookAhead ) return pAction->action;
      if( pAction->next==0 ) break;
      pAction = &pState->hashtbl[pAction->next-1];
    }
#ifdef YYFALLBACK
    if( iLookAhead<sizeof(yyFallback)/sizeof(yyFallback[0])
           && (iFallback = yyFallback[iLookAhead])!=0 ){
#ifndef NDEBUG
      if( yyTraceFILE ){
        fprintf(yyTraceFILE, "%sFALLBACK %s => %s\n",
           yyTracePrompt, yyTokenName[iLookAhead], yyTokenName[iFallback]);
      }
#endif
      return yy_find_parser_action(pParser, iFallback);
    }
#endif
  }else if( pState->hashtbl->lookahead!=YYNOCODE ){
    return YY_NO_ACTION;
  }
  return pState->actionDefault;
}

/*
** Perform a shift action.
*/
static void yy_shift(
  yyParser *yypParser,          /* The parser to be shifted */
  int yyNewState,               /* The new state to shift in */
  int yyMajor,                  /* The major token to shift in */
  YYMINORTYPE *yypMinor         /* Pointer ot the minor token to shift in */
){
  yypParser->yyidx++;
  yypParser->yytop++;
  if( yypParser->yyidx>=YYSTACKDEPTH ){
     ParseARG_FETCH;
     yypParser->yyidx--;
     yypParser->yytop--;
#ifndef NDEBUG
     if( yyTraceFILE ){
       fprintf(yyTraceFILE,"%sStack Overflow!\n",yyTracePrompt);
     }
#endif
     while( yypParser->yyidx>=0 ) yy_pop_parser_stack(yypParser);
     /* Here code is inserted which will execute if the parser
     ** stack every overflows */
     ParseARG_STORE; /* Suppress warning about unused %extra_argument var */
     return;
  }
  yypParser->yytop->stateno = yyNewState;
  yypParser->yytop->major = yyMajor;
  yypParser->yytop->minor = *yypMinor;
#ifndef NDEBUG
  if( yyTraceFILE && yypParser->yyidx>0 ){
    int i;
    fprintf(yyTraceFILE,"%sShift %d\n",yyTracePrompt,yyNewState);
    fprintf(yyTraceFILE,"%sStack:",yyTracePrompt);
    for(i=1; i<=yypParser->yyidx; i++)
      fprintf(yyTraceFILE," %s",yyTokenName[yypParser->yystack[i].major]);
    fprintf(yyTraceFILE,"\n");
  }
#endif
}

/* The following table contains information about every rule that
** is used during the reduce.
*/
static struct {
  YYCODETYPE lhs;         /* Symbol on the left-hand side of the rule */
  unsigned char nrhs;     /* Number of right-hand side symbols in the rule */
} yyRuleInfo[] = {
  { 38, 2 },
  { 38, 1 },
  { 44, 1 },
  { 44, 0 },
  { 48, 0 },
  { 48, 3 },
  { 47, 1 },
  { 47, 1 },
  { 47, 1 },
  { 47, 1 },
  { 47, 1 },
  { 47, 1 },
  { 47, 1 },
  { 49, 2 },
  { 42, 0 },
  { 42, 1 },
  { 24, 1 },
  { 46, 1 },
  { 46, 3 },
  { 45, 1 },
  { 34, 1 },
  { 34, 3 },
  { 33, 1 },
  { 33, 3 },
  { 33, 3 },
  { 25, 1 },
  { 37, 1 },
  { 37, 3 },
  { 41, 0 },
  { 41, 1 },
  { 36, 1 },
  { 36, 1 },
  { 28, 1 },
  { 28, 3 },
  { 32, 1 },
  { 32, 1 },
  { 31, 1 },
  { 35, 1 },
  { 35, 3 },
  { 30, 4 },
  { 43, 0 },
  { 43, 1 },
  { 40, 0 },
  { 40, 1 },
  { 39, 0 },
  { 39, 2 },
  { 26, 3 },
  { 26, 3 },
  { 27, 0 },
  { 27, 2 },
  { 27, 2 },
  { 27, 2 },
};

static void yy_accept(yyParser*);  /* Forward Declaration */

/*
** Perform a reduce action and the shift that must immediately
** follow the reduce.
*/
static void yy_reduce(
  yyParser *yypParser,         /* The parser */
  int yyruleno                 /* Number of the rule by which to reduce */
){
  int yygoto;                     /* The next state */
  int yyact;                      /* The next action */
  YYMINORTYPE yygotominor;        /* The LHS of the rule reduced */
  yyStackEntry *yymsp;            /* The top of the parser's stack */
  int yysize;                     /* Amount to pop the stack */
  ParseARG_FETCH;
  yymsp = yypParser->yytop;
#ifndef NDEBUG
  if( yyTraceFILE && yyruleno>=0 
        && yyruleno<sizeof(yyRuleName)/sizeof(yyRuleName[0]) ){
    fprintf(yyTraceFILE, "%sReduce [%s].\n", yyTracePrompt,
      yyRuleName[yyruleno]);
  }
#endif /* NDEBUG */

  switch( yyruleno ){
  /* Beginning here are the reduction cases.  A typical example
  ** follows:
  **   case 0:
  **  #line <lineno> <grammarfile>
  **     { ... }           // User supplied code
  **  #line <lineno> <thisfile>
  **     break;
  */
      case 0:
#line 67 "mdcTclParse.y"
{yygotominor.yy0= yymsp[0].minor.yy0;}
#line 895 "mdcTclParse.c"
        /* No destructor defined for startingGarbage */
        break;
      case 1:
#line 68 "mdcTclParse.y"
{yygotominor.yy0= NULL;}
#line 901 "mdcTclParse.c"
        /* No destructor defined for error */
        break;
      case 2:
        /* No destructor defined for WORDEND */
        break;
      case 3:
        break;
      case 4:
#line 73 "mdcTclParse.y"
{yygotominor.yy0= Tcl_NewListObj(0,0);}
#line 912 "mdcTclParse.c"
        break;
      case 5:
#line 74 "mdcTclParse.y"
{
	Tcl_ListObjAppendElement(context->interp, yymsp[-2].minor.yy0, yymsp[0].minor.yy0);
	yygotominor.yy0= yymsp[-2].minor.yy0;
}
#line 920 "mdcTclParse.c"
        /* No destructor defined for optSeparator */
        break;
      case 6:
#line 82 "mdcTclParse.y"
{
	yygotominor.yy0= yymsp[0].minor.yy0;
}
#line 928 "mdcTclParse.c"
        break;
      case 7:
#line 86 "mdcTclParse.y"
{
	yygotominor.yy0= yymsp[0].minor.yy0;
}
#line 935 "mdcTclParse.c"
        break;
      case 8:
#line 90 "mdcTclParse.y"
{
	yygotominor.yy0= yymsp[0].minor.yy0;
}
#line 942 "mdcTclParse.c"
        break;
      case 9:
#line 94 "mdcTclParse.y"
{
	yygotominor.yy0= yymsp[0].minor.yy0;
}
#line 949 "mdcTclParse.c"
        break;
      case 10:
#line 98 "mdcTclParse.y"
{
	yygotominor.yy0= yymsp[0].minor.yy0;
}
#line 956 "mdcTclParse.c"
        break;
      case 11:
#line 102 "mdcTclParse.y"
{
	yygotominor.yy0= yymsp[0].minor.yy0;
}
#line 963 "mdcTclParse.c"
        break;
      case 12:
#line 106 "mdcTclParse.y"
{
	yygotominor.yy0= yymsp[0].minor.yy0;
}
#line 970 "mdcTclParse.c"
        break;
      case 13:
#line 112 "mdcTclParse.y"
{
	/* Format for cadrat : {c DATA ?opt1 val1? ?opt2 val2?} */
	/* so we simply append shading : */
	Tcl_ListObjAppendList(context->interp, yymsp[-1].minor.yy0, yymsp[0].minor.yy0);
	yygotominor.yy0= yymsp[-1].minor.yy0;
}
#line 980 "mdcTclParse.c"
        break;
      case 14:
#line 119 "mdcTclParse.y"
{	yygotominor.yy0= Tcl_NewListObj(0,0);
}
#line 986 "mdcTclParse.c"
        break;
      case 15:
#line 122 "mdcTclParse.y"
{
	/*
	 * Shading is a integer :
	 * 1 means first quarter is shaded
	 * 2 means second quarter is shaded
	 * 4 means third quarter is shaded
	 * 8 means fourth quarter is shaded
	 *
	 * combining these is done by adding the corresponding values.
	 * 
	 * Thus, if both first, second and fourth quarters are shaded,
	 * shading's value will be 1+2+8= 11
	 */
	yygotominor.yy0= Tksesh_NewTclCouple(Tksesh_NewTclKeyword("shading"), yymsp[0].minor.yy0);
}
#line 1005 "mdcTclParse.c"
        break;
      case 16:
#line 140 "mdcTclParse.y"
{
	yygotominor.yy0= Tksesh_NewTclCouple(Tksesh_NewTclKeyword("c"),yymsp[0].minor.yy0);
}
#line 1012 "mdcTclParse.c"
        break;
      case 17:
#line 144 "mdcTclParse.y"
{
	yygotominor.yy0= Tksesh_NewTclSingleton(yymsp[0].minor.yy0);
}
#line 1019 "mdcTclParse.c"
        break;
      case 18:
#line 149 "mdcTclParse.y"
{
	Tcl_ListObjAppendElement(context->interp, yymsp[-2].minor.yy0, yymsp[0].minor.yy0);
	yygotominor.yy0= yymsp[-2].minor.yy0;
}
#line 1027 "mdcTclParse.c"
        /* No destructor defined for COLUMN */
        break;
      case 19:
#line 157 "mdcTclParse.y"
{
	yygotominor.yy0= yymsp[0].minor.yy0;
}
#line 1035 "mdcTclParse.c"
        break;
      case 20:
#line 162 "mdcTclParse.y"
{
	yygotominor.yy0= Tksesh_NewTclSingleton(yymsp[0].minor.yy0);
}
#line 1042 "mdcTclParse.c"
        break;
      case 21:
#line 167 "mdcTclParse.y"
{
	Tcl_ListObjAppendElement(context->interp, yymsp[-2].minor.yy0, yymsp[0].minor.yy0);
	yygotominor.yy0= yymsp[-2].minor.yy0;
}
#line 1050 "mdcTclParse.c"
        /* No destructor defined for STAR */
        break;
      case 22:
#line 175 "mdcTclParse.y"
{
	yygotominor.yy0= yymsp[0].minor.yy0;
}
#line 1058 "mdcTclParse.c"
        break;
      case 23:
#line 180 "mdcTclParse.y"
{	
		yygotominor.yy0= Tksesh_NewTclCouple(Tksesh_NewTclKeyword("philology"),yymsp[-1].minor.yy0);
		yygotominor.yy0= yymsp[-2].minor.yy0;
		yygotominor.yy0= yymsp[0].minor.yy0;
	/* Now, compute and add information about what kind of philological
     comments we have : TO DO */
	
}
#line 1070 "mdcTclParse.c"
        break;
      case 24:
#line 190 "mdcTclParse.y"
{
	yygotominor.yy0= yymsp[-1].minor.yy0;
}
#line 1077 "mdcTclParse.c"
        /* No destructor defined for BPAR */
        /* No destructor defined for EPAR */
        break;
      case 25:
#line 197 "mdcTclParse.y"
{
	yygotominor.yy0= Tksesh_NewTclCouple(Tksesh_NewTclKeyword("subcadrat"),yymsp[0].minor.yy0);
}
#line 1086 "mdcTclParse.c"
        break;
      case 26:
#line 202 "mdcTclParse.y"
{
	yygotominor.yy0= Tksesh_NewTclSingleton(yymsp[0].minor.yy0);
}
#line 1093 "mdcTclParse.c"
        break;
      case 27:
#line 207 "mdcTclParse.y"
{
	Tcl_ListObjAppendElement(context->interp, yymsp[-2].minor.yy0, yymsp[0].minor.yy0);
	yygotominor.yy0= yymsp[-2].minor.yy0;
}
#line 1101 "mdcTclParse.c"
        /* No destructor defined for optSeparator */
        break;
      case 28:
        break;
      case 29:
        /* No destructor defined for SEPARATOR */
        break;
      case 30:
#line 218 "mdcTclParse.y"
{
	yygotominor.yy0= yymsp[0].minor.yy0;
}
#line 1114 "mdcTclParse.c"
        break;
      case 31:
#line 223 "mdcTclParse.y"
{
	yygotominor.yy0= Tksesh_NewTclCouple(Tksesh_NewTclKeyword("latin"),yymsp[0].minor.yy0);
}
#line 1121 "mdcTclParse.c"
        break;
      case 32:
#line 230 "mdcTclParse.y"
{
	yygotominor.yy0= yymsp[0].minor.yy0;
}
#line 1128 "mdcTclParse.c"
        break;
      case 33:
#line 235 "mdcTclParse.y"
{
	yygotominor.yy0= Tksesh_NewTclTriplet(Tksesh_NewTclKeyword("overwrite"), yymsp[-2].minor.yy0, yymsp[0].minor.yy0);
}
#line 1135 "mdcTclParse.c"
        /* No destructor defined for OVERWRITE */
        break;
      case 34:
#line 240 "mdcTclParse.y"
{
	yygotominor.yy0= yymsp[0].minor.yy0;
}
#line 1143 "mdcTclParse.c"
        break;
      case 35:
#line 245 "mdcTclParse.y"
{
	yygotominor.yy0= yymsp[0].minor.yy0;
}
#line 1150 "mdcTclParse.c"
        break;
      case 36:
#line 253 "mdcTclParse.y"
{
	int l;
	Tcl_ListObjLength(context->interp, yymsp[0].minor.yy0, &l);
	if (l == 1) {
		yygotominor.yy0= yymsp[0].minor.yy0;
	} else {
		yygotominor.yy0= Tksesh_NewTclCouple(Tksesh_NewTclKeyword("lig"), yymsp[0].minor.yy0);
	}
}
#line 1163 "mdcTclParse.c"
        break;
      case 37:
#line 264 "mdcTclParse.y"
{
	yygotominor.yy0= Tksesh_NewTclSingleton(yymsp[0].minor.yy0);
}
#line 1170 "mdcTclParse.c"
        break;
      case 38:
#line 269 "mdcTclParse.y"
{
	Tcl_ListObjAppendElement(context->interp, yymsp[-2].minor.yy0, yymsp[0].minor.yy0);
	yygotominor.yy0= yymsp[-2].minor.yy0;
}
#line 1178 "mdcTclParse.c"
        /* No destructor defined for AMP */
        break;
      case 39:
#line 277 "mdcTclParse.y"
{
		yygotominor.yy0= Tksesh_NewTclCouple(Tksesh_NewTclKeyword("s"), yymsp[-2].minor.yy0);
		Tcl_ListObjAppendList(context->interp, yygotominor.yy0, yymsp[-1].minor.yy0);
		if (yymsp[0].minor.yy92) {
				Tcl_ListObjAppendElement(context->interp, yygotominor.yy0, 
																 Tksesh_NewTclCouple(Tksesh_NewTclKeyword("wordend"),
																										 Tcl_NewIntObj(1)));
		}
		if (yymsp[-3].minor.yy92) {
				Tcl_ListObjAppendElement(context->interp, yygotominor.yy0, 
																 Tksesh_NewTclCouple(Tksesh_NewTclKeyword("gram"),
																										 Tcl_NewIntObj(1)));
		}
}
#line 1197 "mdcTclParse.c"
        break;
      case 40:
#line 293 "mdcTclParse.y"
{
	yygotominor.yy92= FALSE;
}
#line 1204 "mdcTclParse.c"
        break;
      case 41:
#line 298 "mdcTclParse.y"
{
	yygotominor.yy92= TRUE;
}
#line 1211 "mdcTclParse.c"
        /* No destructor defined for WORDEND */
        break;
      case 42:
#line 303 "mdcTclParse.y"
{
	yygotominor.yy92= FALSE;
}
#line 1219 "mdcTclParse.c"
        break;
      case 43:
#line 308 "mdcTclParse.y"
{
	yygotominor.yy92= TRUE;
}
#line 1226 "mdcTclParse.c"
        /* No destructor defined for GRAMMAR */
        break;
      case 44:
#line 313 "mdcTclParse.y"
{
	yygotominor.yy0= Tcl_NewListObj(0,0);
}
#line 1234 "mdcTclParse.c"
        break;
      case 45:
#line 318 "mdcTclParse.y"
{
	Tcl_ListObjAppendElement(context->interp, yymsp[-1].minor.yy0, yymsp[0].minor.yy0);
	yygotominor.yy0= yymsp[-1].minor.yy0;
}
#line 1242 "mdcTclParse.c"
        break;
      case 46:
#line 327 "mdcTclParse.y"
{
	yygotominor.yy0= Tksesh_NewTclCouple(Tksesh_NewTclKeyword("cartouche"), yymsp[-1].minor.yy0);
}
#line 1249 "mdcTclParse.c"
        /* No destructor defined for BEGINCARTOUCHE */
        /* No destructor defined for ENDCARTOUCHE */
        break;
      case 47:
#line 332 "mdcTclParse.y"
{
	yygotominor.yy0= Tksesh_NewTclCouple(Tksesh_NewTclKeyword("cartouche"), yymsp[-1].minor.yy0);
}
#line 1258 "mdcTclParse.c"
        /* No destructor defined for BEGINOLDCARTOUCHE */
        /* No destructor defined for ENDCARTOUCHE */
        break;
      case 48:
#line 337 "mdcTclParse.y"
{
	yygotominor.yy0= Tcl_NewListObj(0,0);
}
#line 1267 "mdcTclParse.c"
        break;
      case 49:
#line 342 "mdcTclParse.y"
{
	Tcl_ListObjAppendElement(context->interp, yymsp[-1].minor.yy0, yymsp[0].minor.yy0);
	yygotominor.yy0= yymsp[-1].minor.yy0;
}
#line 1275 "mdcTclParse.c"
        break;
      case 50:
#line 348 "mdcTclParse.y"
{
	Tcl_ListObjAppendElement(context->interp, yymsp[-1].minor.yy0, yymsp[0].minor.yy0);
	yygotominor.yy0= yymsp[-1].minor.yy0;
}
#line 1283 "mdcTclParse.c"
        break;
      case 51:
#line 354 "mdcTclParse.y"
{
	Tcl_ListObjAppendElement(context->interp, yymsp[-1].minor.yy0, yymsp[0].minor.yy0);
	yygotominor.yy0= yymsp[-1].minor.yy0;
}
#line 1291 "mdcTclParse.c"
        break;
  };
  yygoto = yyRuleInfo[yyruleno].lhs;
  yysize = yyRuleInfo[yyruleno].nrhs;
  yypParser->yyidx -= yysize;
  yypParser->yytop -= yysize;
  yyact = yy_find_parser_action(yypParser,yygoto);
  if( yyact < YYNSTATE ){
    yy_shift(yypParser,yyact,yygoto,&yygotominor);
  }else if( yyact == YYNSTATE + YYNRULE + 1 ){
    yy_accept(yypParser);
  }
}

/*
** The following code executes when the parse fails
*/
static void yy_parse_failed(
  yyParser *yypParser           /* The parser */
){
  ParseARG_FETCH;
#ifndef NDEBUG
  if( yyTraceFILE ){
    fprintf(yyTraceFILE,"%sFail!\n",yyTracePrompt);
  }
#endif
  while( yypParser->yyidx>=0 ) yy_pop_parser_stack(yypParser);
  /* Here code is inserted which will be executed whenever the
  ** parser fails */
  ParseARG_STORE; /* Suppress warning about unused %extra_argument variable */
}

/*
** The following code executes when a syntax error first occurs.
*/
static void yy_syntax_error(
  yyParser *yypParser,           /* The parser */
  int yymajor,                   /* The major type of the error token */
  YYMINORTYPE yyminor            /* The minor type of the error token */
){
  ParseARG_FETCH;
#define TOKEN (yyminor.yy0)
  ParseARG_STORE; /* Suppress warning about unused %extra_argument variable */
}

/*
** The following is executed when the parser accepts
*/
static void yy_accept(
  yyParser *yypParser           /* The parser */
){
  ParseARG_FETCH;
#ifndef NDEBUG
  if( yyTraceFILE ){
    fprintf(yyTraceFILE,"%sAccept!\n",yyTracePrompt);
  }
#endif
  while( yypParser->yyidx>=0 ) yy_pop_parser_stack(yypParser);
  /* Here code is inserted which will be executed whenever the
  ** parser accepts */
  ParseARG_STORE; /* Suppress warning about unused %extra_argument variable */
}

/* The main parser program.
** The first argument is a pointer to a structure obtained from
** "ParseAlloc" which describes the current state of the parser.
** The second argument is the major token number.  The third is
** the minor token.  The fourth optional argument is whatever the
** user wants (and specified in the grammar) and is available for
** use by the action routines.
**
** Inputs:
** <ul>
** <li> A pointer to the parser (an opaque structure.)
** <li> The major token number.
** <li> The minor token number.
** <li> An option argument of a grammar-specified type.
** </ul>
**
** Outputs:
** None.
*/
void Parse(
  void *yyp,                   /* The parser */
  int yymajor,                 /* The major token code number */
  ParseTOKENTYPE yyminor       /* The value for the token */
  ParseARG_PDECL               /* Optional %extra_argument parameter */
){
  YYMINORTYPE yyminorunion;
  int yyact;            /* The parser action. */
  int yyendofinput;     /* True if we are at the end of input */
  int yyerrorhit = 0;   /* True if yymajor has invoked an error */
  yyParser *yypParser;  /* The parser */

  /* (re)initialize the parser, if necessary */
  yypParser = (yyParser*)yyp;
  if( yypParser->yyidx<0 ){
    if( yymajor==0 ) return;
    yypParser->yyidx = 0;
    yypParser->yyerrcnt = -1;
    yypParser->yytop = &yypParser->yystack[0];
    yypParser->yytop->stateno = 0;
    yypParser->yytop->major = 0;
  }
  yyminorunion.yy0 = yyminor;
  yyendofinput = (yymajor==0);
  ParseARG_STORE;

#ifndef NDEBUG
  if( yyTraceFILE ){
    fprintf(yyTraceFILE,"%sInput %s\n",yyTracePrompt,yyTokenName[yymajor]);
  }
#endif

  do{
    yyact = yy_find_parser_action(yypParser,yymajor);
    if( yyact<YYNSTATE ){
      yy_shift(yypParser,yyact,yymajor,&yyminorunion);
      yypParser->yyerrcnt--;
      if( yyendofinput && yypParser->yyidx>=0 ){
        yymajor = 0;
      }else{
        yymajor = YYNOCODE;
      }
    }else if( yyact < YYNSTATE + YYNRULE ){
      yy_reduce(yypParser,yyact-YYNSTATE);
    }else if( yyact == YY_ERROR_ACTION ){
#ifndef NDEBUG
      if( yyTraceFILE ){
        fprintf(yyTraceFILE,"%sSyntax Error!\n",yyTracePrompt);
      }
#endif
#ifdef YYERRORSYMBOL
      /* A syntax error has occurred.
      ** The response to an error depends upon whether or not the
      ** grammar defines an error token "ERROR".  
      **
      ** This is what we do if the grammar does define ERROR:
      **
      **  * Call the %syntax_error function.
      **
      **  * Begin popping the stack until we enter a state where
      **    it is legal to shift the error symbol, then shift
      **    the error symbol.
      **
      **  * Set the error count to three.
      **
      **  * Begin accepting and shifting new tokens.  No new error
      **    processing will occur until three tokens have been
      **    shifted successfully.
      **
      */
      if( yypParser->yyerrcnt<0 ){
        yy_syntax_error(yypParser,yymajor,yyminorunion);
      }
      if( yypParser->yytop->major==YYERRORSYMBOL || yyerrorhit ){
#ifndef NDEBUG
        if( yyTraceFILE ){
          fprintf(yyTraceFILE,"%sDiscard input token %s\n",
             yyTracePrompt,yyTokenName[yymajor]);
        }
#endif
        yy_destructor(yymajor,&yyminorunion);
        yymajor = YYNOCODE;
      }else{
         while(
          yypParser->yyidx >= 0 &&
          yypParser->yytop->major != YYERRORSYMBOL &&
          (yyact = yy_find_parser_action(yypParser,YYERRORSYMBOL)) >= YYNSTATE
        ){
          yy_pop_parser_stack(yypParser);
        }
        if( yypParser->yyidx < 0 || yymajor==0 ){
          yy_destructor(yymajor,&yyminorunion);
          yy_parse_failed(yypParser);
          yymajor = YYNOCODE;
        }else if( yypParser->yytop->major!=YYERRORSYMBOL ){
          YYMINORTYPE u2;
          u2.YYERRSYMDT = 0;
          yy_shift(yypParser,yyact,YYERRORSYMBOL,&u2);
        }
      }
      yypParser->yyerrcnt = 3;
      yyerrorhit = 1;
#else  /* YYERRORSYMBOL is not defined */
      /* This is what we do if the grammar does not define ERROR:
      **
      **  * Report an error message, and throw away the input token.
      **
      **  * If the input token is $, then fail the parse.
      **
      ** As before, subsequent error messages are suppressed until
      ** three input tokens have been successfully shifted.
      */
      if( yypParser->yyerrcnt<=0 ){
        yy_syntax_error(yypParser,yymajor,yyminorunion);
      }
      yypParser->yyerrcnt = 3;
      yy_destructor(yymajor,&yyminorunion);
      if( yyendofinput ){
        yy_parse_failed(yypParser);
      }
      yymajor = YYNOCODE;
#endif
    }else{
      yy_accept(yypParser);
      yymajor = YYNOCODE;
    }
  }while( yymajor!=YYNOCODE && yypParser->yyidx>=0 );
  return;
}
#line 359 "mdcTclParse.y"

	
	
	/**
	 */
	
	void
		parseMDC(char * mdc) {
		
		pParser = ParseAlloc( malloc );
		
		while( GetNextToken(pTokenizer, &hTokenId, &sToken) ){
			/* Parse( parser, token type, token value, context) */
			Parse(pParser, hTokenId, sToken, &sState);
		}
		/* notify the end of file */
		Parse(pParser, 0, sToken, &sState);
		
		/* free the parser */
		ParseFree(pParser, free );
		
	}

#line 1527 "mdcTclParse.c"
