#ifndef SIMPLEFILE_H
#define SIMPLEFILE_H

#include <stdio.h>
#include <unistd.h>

/* Windows compatibility */
#ifndef O_BINARY
#define O_BINARY 0
#endif

/* #define USEPOSIXFILE*/


enum MyOpenFlags {MYREAD, MYCREATE, MYWRITE};

#ifdef USEPOSIXFILE
struct MyFile {
  int f;
  int last_was_write;
};

#else
struct MyFile {
  FILE * f;
  int last_was_write;
};

#endif

int
MyOpen(struct MyFile *f, char *name, enum MyOpenFlags flags);

void
MyClose(struct MyFile *f);

int
MyWrite(struct MyFile *f, void *buf, size_t count);

int
MyRead(struct MyFile *f, void *buf, size_t count);

void
MySeek(struct MyFile *f, long offset, int whence);

int
MyTell(struct MyFile *f);

int
MyAccess(char *name, int flag);

#endif
