
#define _POSIX_SOURCE 1

#include "general.h"
#include "bigstr.h"

#ifndef NULL
#define NULL 0
#endif

static void
BigString_error(char *s)
{
  exit(2);
}

BigString *
create_BigString()
{
	BigString *b;
	b= (BigString *) ALLOUER(sizeof(BigString));
	if (!b)
	  BigString_error("Not enough memory for BigString creation");
	b->used=0;
	b->size= BS_INCR;
	b->string= (char*) ALLOUER((unsigned)BS_INCR*sizeof(char));
	if (!b->string)
	  BigString_error("Not enough memory for BigString creation");
	b->string[0]= 0;
	return b;
}

void
reset_BigString(BigString *b)
{
	b->used=0;
	b->string[0]= 0;
}

char * 
string_from_BigString(BigString *b)
{
	return b->string;
}

char * 
extract_string_from_BigString(BigString *b)
{
	char *s;
	s= b->string;
	b->used=0;
	b->size= BS_INCR;
	b->string= (char*) ALLOUER((unsigned)BS_INCR*sizeof(char));
	if (!b->string)
	  BigString_error("Not enough memory for string duplication");
	b->string[0]= 0;
	return s;
}

void
add_to_BigString(BigString *b, char c)
{
	if (b->used == b->size - 1)
	{
		b->string= (char *) REALLOUER(b->string, b->size + (unsigned) BS_INCR);
		if (!b->string)
		  BigString_error("Not enough memory");
		b->size+= (unsigned) BS_INCR;
	}
	b->string[(b->used)++]= c;
	b->string[b->used]= 0;
}		

void
append_to_BigString(BigString *b, char *s)
{
	while (*s)
	{
		add_to_BigString(b,*(s++));
	}
}

void 
delete_last_from_BigString(BigString *b)
{
	if (b->used)
	{
		(b->used)--;
		b->string[b->used]= 0;
	}
}

void
delete_BigString(BigString *b)
{
	LIBERE(b->string);
	LIBERE(b);
}

void
dissolve_BigString_in_string(BigString **b, char **s)
{
	*s= (*b)->string;
	LIBERE(*b);
	*b= NULL;
}

