
#define _POSIX_SOURCE 1

/* 
	 growing-strings
*/

#define inline


#ifdef TKSESH_DEBUG
#include <assert.h>
#define ASSERT(X) assert(X)
#else
#define ASSERT(X)
#endif

#include <string.h>

#include "general.h"

#ifndef NULL
#define NULL 0
#endif

#include "chaine.h"

const Chaine empty_chaine=0;

inline unsigned int 
size_of_Chaine(Chaine s)
{
	return (s)->used;
}

inline void 
init_Chaine (Chaine *s, unsigned int size)
{
	*s= (struct _Chaine *)ALLOUER(sizeof(struct _Chaine));
	(*s)->used= 0;
	(*s)->usable= INCREMENT;
	(*s)->data= (void *)ALLOUER(INCREMENT*size);
	(*s)->size= size;
}

inline void
free_Chaine(Chaine s)
{
	LIBERE(s->data);
	s->data= 0;
	LIBERE(s);
}

inline void 
reset_Chaine(Chaine s)
{
	s->used= 0;
}

void * 
Chaine_to_cstring(Chaine s)
{
	void * data;
	data= (void *)ALLOUER(s->size*s->used);
	memcpy(data,s->data,s->size*s->used);
	return data;
}

void * 
Chaine_to_data(Chaine s)
{
	return s->data;
}

void 
add_to_Chaine(Chaine s, void *dat)
{
	(s)->used++;
	if ((s)->used > (s)->usable)
	{
		(s)->usable+= INCREMENT;
		s->data= REALLOUER(s->data, (s)->usable* (s)->size);
		ASSERT(s->data);
	}
	memcpy(s->data +((s)->used - 1) * s->size , dat,s->size);
}

void * 
get_from_Chaine(Chaine s, unsigned int number)
{
	ASSERT (number < s->used);
	return s->data + number * s->size;
}

void
restrict_Chaine_size_to(Chaine s, unsigned int number)
{
	ASSERT (number <= s->used);
	s->used= number;
}

/*
 * Local Variables:
 * tab-width: 2
 * End:
 */
