#ifndef CHAINE_H
#define CHAINE_H
#define INCREMENT 16

#define __inline__
typedef struct _Chaine
{
	unsigned int used;
	unsigned int usable;
	unsigned int size;
	char * data;
} *Chaine;

extern const Chaine empty_chaine;

/* length of the array */
__inline__ unsigned int 
size_of_Chaine(Chaine s);

/* array initialisation. size is the size of the base data type */
__inline__ void 
init_Chaine (Chaine *s, unsigned int size);

/* Empty the array */
__inline__ void 
reset_Chaine(Chaine s);

/* return the array in C form, in an acceptable way for a C programm */
void * 
Chaine_to_data(Chaine s);

/* return a COPY of the array */
void * 
Chaine_to_cstring(Chaine s);

void 
add_to_Chaine(Chaine s, void *dat);

void * 
get_from_Chaine(Chaine s, unsigned int number);

void
restrict_Chaine_size_to(Chaine s, unsigned int number);

void
free_Chaine(Chaine s);

#endif
