/**********************************************************************
 * Code dealing with ligatures at the widget level : 
 *   retrieval & co
 *
 */

/**
 * What we start with is a list of signs (a liggroup)
 * We will attach to it the ligature explaining how to render it.
 */
#define _POSIX_SOURCE 1

#include <tcl.h>

#include "general.h"
#include "tksinter.h"
#include "quadra.h"
#include "ligatur.h"

PUBLIC void
fix_ligature(struct Liggroup *l)
{
  struct Ligature *l1;
  Tcl_HashEntry * entree;
  struct _Signinlig *s;
  struct tksesh_global *g;
  int i;

  g= tksesh_get_global();
  l1= ligature_create(l->nbr);

  s= l->signs;
  for(i=0; i< l->nbr && s != NULL; i++, s= s->next)
    ligature_subsign_init(l1, i, s->sign->donnees.hieroglyphe.rep, 0, 0, 0);
  ligature_make_ident(l1);

  entree= Tcl_FindHashEntry(g->ligatures,
			    ligature_to_code(l1));
  ligature_delete(l1);
  if (entree)
    l->l= (struct Ligature *)Tcl_GetHashValue(entree);
  else
    l->l= NULL;
}
