/**********************************************************************
 *	       Functions to define and retrieve signs.                    *
 *********************************************************************/

#define _POSIX_SOURCE 1


#include <stdio.h>
#ifndef __MWERKS__	
/* #include <varargs.h> */
#endif
#include <assert.h>
#include "hache.h"
#include "seshaux.h"
#include "tksinter.h"
#include "duplique.h"

PRIVATE TABLE 
definitions;
/* PUBLIC TABLE phonetiques; not used now */

GLOBALVAR int 
seshnumligne;

GLOBALVAR int 
signe_trouve;

/**
 *
 * This function is called when a given code is 
 * not found.
 * 
 * Its job is to load the corresponding sign if possible
 * 
 */

static void (*loadSignFunction)(char *code)= NULL;

enum direction { gauche_a_droite, droite_a_gauche};

struct newglyph {
	char * code;
	Lettre *l;
};

struct donne {
	char * entree;
	char * phon;
	struct caractere {int sym; unsigned  char numero; char * code;} symbole;
};

/**
 * PUBLIC union _Donnees 
 * seshtrouvesigne(char *x, int sens)
 * 
 * sends  back the data for a given sign
 */

PUBLIC union _Donnees 
seshtrouvesigne(char *code)
{
	union _Donnees D;
	struct newglyph* g;
	struct tksesh_global *global;

	global= tksesh_get_global();

	if ((g=(struct newglyph*)trouve(code,definitions)))
		{
			signe_trouve= TRUE;
			D.hieroglyphe.rep= g->code;
			D.hieroglyphe.l= g->l;				
		}

	/* If the sign wasn't found, try the sign loading function. */
	if (g== NULL && loadSignFunction != NULL)
		{
			loadSignFunction(code);
			if ((g=(struct newglyph*)trouve(code,definitions)))
				{
					signe_trouve= TRUE;
					D.hieroglyphe.rep= g->code;
					D.hieroglyphe.l= g->l;				
				}
		}
	
	signe_trouve= (g != NULL);
	return D;
}



PUBLIC void 
definit_lettre(char *code, Lettre *l)
{
	/* ATTENTION : PROVISOIRE. IL FAUDRA POUVOIR DETRUIRE CETTE LIGNE PAR LA SUITE */
	struct newglyph *g, *old;
	old= (struct newglyph*)trouve(code,definitions);
	if (old)
		{
			/* here we should see to it that the space used for a
				 letter is freed. but 
				 BZR_delete_lettre(old->l);
				 is not exactly what is needed, since a sign can have more than one name.
				 Reference counting would be solution.
			*/
			old->l= l;
		}
	else {
		g= NOUV(struct newglyph);
		g->code= dupliquechaine(code);
		g->l= l;
		insere(g->code, g, definitions);
	}
}



PUBLIC void
SESH_setLoadSignFunction(void (*f)(char *))
{
  loadSignFunction= f;
}



/**
 * PUBLIC void 
 * initialise_lex()
 * 
 * should be called before using the parsing functions
 */

PUBLIC void 
initialise_lex()
{
		definitions= creer_table();
}
/*
 * Local Variables:
 * header: "seshaux.h"
 * tab-width: 2
 * End:
 */
