/*
 * write the selection to a given device
 */

/*  2000 Serge Rosmorduc,
 * quipe EC.art, Laboratoire LRIA, Universit de Paris 8
 *
 * 15 rue Catulienne
 * 93236 St Denis Cedex
 * FRANCE
 *
 * Tout droits rservs.
 * 
 * voyez le fichier ../LICENCE.txt pour plus d'informations
 * See the ../LICENCEE.txt file for more information
 *
 * $Id: tks2dev.c,v 1.1.1.1 2002/04/16 13:55:00 rosmord Exp $
 *
 */

/*
 * $Log: tks2dev.c,v $
 * Revision 1.1.1.1  2002/04/16 13:55:00  rosmord
 * Imported using tkCVS
 *
 * Revision 1.1  2000/08/04 11:49:57  rosmord
 * Initial revision
 *
 */

#include "tks2dev.h"
#include "affsigne.h"

#define POSX0 0.1

void
tks2dev(Sesh *hiero, TKSESH_output * dev, GeneralIndex gdebut, GeneralIndex gfin)
{
  Texte * deb, *fin;
  Texte * tt;
  double posx, posy, dy;  
  // double hierolineH= hiero->resolution;

  deb= GETTEXTOF(gdebut);
  fin= GETTEXTOF(gfin);
  SESH_ordonner_Texte(&deb, &fin);

  if (!deb->next)
    return;
 
  tt= deb->next;

  dy= 1.2;
  posx= POSX0;
  posy= -1;
  // posy-= dy;

  while (tt != fin->next)
    {
      /* temporary hack. See below. */
      /* tt->real_dims= FALSE;*/
      
      TKSO_SET_STATE(dev, tt->couleur);
      switch (tt->type) 
	{
	case T_TEXTE:
	  {
	    double y;
	    y= posy;
	  // tt->h= hierolineH;
	  // if (posx + SESH_texte_width(tt) > dev->window.urx)
	  // {
	  // posy -= dy;
	  // posx = POSX0;
	  // }
	  // Pour l'instant, pas de rendu en colonnes
	  // hierolineH ???
	  SESH_aff_texte(dev, &hiero->geom, &posx, &y, tt);
	  }
	  break;
	case T_NL:
	  posy -= dy;
	  posx= POSX0;
	  break;
	case T_NP:
	  {
	    posy -= dy;
	    posx= POSX0;
	    break;
	  }
	case T_LIGNE_COMMENTAIRE:
	  break;
	case T_FIXE_COORDONNEES:
	    break;
	}
      /* Temporary hack. See above */
      /*  tt->real_dims= FALSE;*/
      tt= tt->next;
    }
}
