
package require stooop

package provide seshDico 0.0	;# This uses Tcl namespaces

# Dictionary workflow.
# Note that a different workflow will be attached to each dictionary editor.
# Currently adapted to the old dictionary structure.
# Will evolve violently

class DicoWF {
    
    proc DicoWF {this type} {
	set ($this,rootTag) $type
	set ($this,upperTag) $type
	set ($this,oldTags) [list]
	resetEntryID $this
	resetWF $this
    }
    
    proc getRootTag {this} {
	return $($this,rootTag)
    }

    proc hasChanged {this} {
	return $($this,hasChanged)
    }

    proc PRIVsetChanged {this changed} {
	set ($this,hasChanged) $changed
    }
    
    proc ~DicoWF {this} {
    }

    proc resetWF {this} {
	# does the window display an old value ?
        PRIVsetChanged $this 0
    }

    proc resetEntryID {this} {
	set db [TkseshDB::getTkseshDB]
	PRIVsetId $this "NULL"
	PRIVsetUid $this [TkseshDB::getUid $db]
	PRIVsetMid $this [TkseshDB::getMid $db]
	PRIVsetOid $this -1
	# The following are not currently used :
	PRIVsetDate $this [TkseshDB::getDate]
	PRIVsetSid $this  [TkseshDB::getSid $db]
    }

    proc getID {this} {
	return $($this,id)
    }

    proc PRIVsetId {this id} {
	set ($this,id) $id
    }

    proc getUid {this} {
	return $($this,uid)
    }

    proc PRIVsetUid {this uid} {
	set ($this,uid) $uid
    }
    
    proc getMid {this} {
	return $($this,mid)
    }

    proc PRIVsetMid {this mid} {
	set ($this,mid) $mid
    }

    proc PRIVsetOid {this oid} {
	set ($this,oid) $oid
    }
    
    proc getOid {this} {
	return $($this,oid)
    }

    proc getDate {this} {
	return $($this,date)
    }

    proc PRIVsetDate {this date} {
	set ($this,date) $date
    }

    proc getSid {this} {
	return $($this,sid)
    }

    proc PRIVsetSid {this sid} {
	set ($this,sid) $sid
    }

    # Return true if the current entry ID is valid :
    # 
    proc hasEntryID {this} {
	return [expr {[getID $this] ne "NULL"}]
    }
    
    # Save an entry in the database.
    # if no id is associated with the entry, create one.
    
    proc saveEntry {this txt} {
	set db [TkseshDB::getTkseshDB]
	set uid [TkseshDB::getUid $db]
	set mid [TkseshDB::getMid $db]
	set date [TkseshDB::getDate] 
	set sid [TkseshDB::getSid $db] 
	# If the record is new, or doesn't belong to its saver, get a number
	if {(! [hasEntryID $this]) || [isNotMine $this]} {
	    set id "NULL"
	    puts "creating new record : hasid : [hasEntryID $this], not mine : [isNotMine $this]"
	} else {
	    set id [getID $this]
	}
	writeEntry $uid $mid $id $txt
    }

    # dicoWF::isNotMine
    # returns true if the owner of the current record is
    # not the current user.
    # 
    proc isNotMine {this} {
	set euid [getUid $this]
	set db [TkseshDB::getTkseshDB]
	set uid [TkseshDB::getUid $db]
	puts "record uid is $euid ; I am $uid"
	return [expr {$uid != $euid}]
    }
    
    proc setEntry {this oid} {
	set ($this,text) [DicoDAL::getEntry $oid]
	set cid [DicoDAL::getID $oid]
	puts "record data : $cid"
	PRIVsetOid $this $oid
	PRIVsetId $this [lindex $cid 0]
	PRIVsetUid $this [lindex $cid 1]
	PRIVsetMid $this [lindex $cid 2]
	PRIVsetDate $this [lindex $cid 3]
	PRIVsetSid $this [lindex $cid 4]	
	set ($this,oldTags) [TagHandler::listIndexedTags $($this,text)]
    }

    proc getEntryText {this} {
	return $($this,text)
    }

    # Static methods.
    
    # returns the list id for  entries associated with an index.
    # tag : the tag name
    # value : the tag value to search
    # sub : find a substring of the value.
    proc findEntriesByIndex {tag value {sub 0}} {
	puts "searching $tag $value"
	set norm [TagHandler::getNormalizedValue $tag $value]
	puts "searching $tag $value : $norm"
	return [DicoDAL::getEntriesIdForTag $tag $norm $sub]
    }

    #
    # get_orth --
    # sends back a list of couples :
    #   {trans orth}
    # where trans is a transliteration found in the definition
    # and orth is one of its orthographies.
    
    # get_orth returns a list of the form :
    # trans orthographies trans orthographies ...
    
    proc get_orth {txt} {
	array set tmp {}
	set res [build_orth [list $txt] {} {}]
	# for a given group or subgroup,
	# all transliterations and all orthographies are supposed to be
	# equivalent.

	# First, compute (in tmp) the set of orthographies for each transliteration.
	foreach sub $res {
	    set trs [lindex $sub 0]
	    set h [lindex $sub 1]
	    foreach tr $trs {
		set v {}
		if [info exists tmp($tr)] {
		    set v $tmp($tr)
		}
		set tmp($tr) [concat $v $h]
	    } 
	}
	# now, build result as a list of the form : translit0 ortho0 translit ortho ...
	set result [list]
	foreach {t orthographies} [array get tmp] {
	    foreach o $orthographies {
		lappend result $t $o
	    }
	}
	return $result
    }

    # Build(txt, previous_t, previous_h)
    # Algorithm : we begin with an environment
    # which can contain a list of orthographies and/or of transliterations,
    #
    #
    # For the current group :
    #    g:= list of all subgroups.
    #    t:= list of transliterations in current group.
    #    h:= list of orthographies in current group.
    #
    #    if t = {} then t0:= previous_t else t0:= t
    #    if h = {} then h0:= previous_h else h0:= h
    #    
    #    result:= {}
    #
    #    if t != {}  or h != {}
    #      result:= {{t0 h0}}
    #
    #    foreach gr in g 
    #      b1:= Build(gr, t0, h0, result)
    #      result:= result + b1
    #
    #    return result

    proc build_orth {txt prevt prevh} {
	set t [find_translit $txt]
	set h [find_hiero $txt]
	set g [find_subgroups $txt]
	
	if [empty_list $t] {
	    set t0 $prevt
	} else {
	    set t0 $t
	}

	if [empty_list $h] {
	    set h0 $prevh
	} else {
	    set h0 $h
	}
	
	if {! [empty_list $t] || ! [empty_list $h]} {
	    set result [list [list $t0 $h0]]
	} else {
	    set result {}
	}
	
	foreach gr $g {
	    set b1 [build_orth $gr $t0 $h0]
	    set result [concat $result $b1]
	}
	return $result
    }

    proc find_translit {txt} {
	set res {}
	foreach elt $txt {
	    if [regexp {^MTRI *{(.*)}$} $elt dum tra] {
		lappend res $tra
	    }
	}
	return $res
    }

    proc find_hiero {txt} {
	set res {}
	foreach elt $txt {
	    if [regexp {^WRI *{(.*)}$} $elt dum tra] {
		lappend res $tra
	    }
	}
	return $res
    }

    proc find_subgroups {txt} {
	set res {}
	foreach elt $txt {
	    if [regexp {^GRP *{(.*)}$} $elt dum tra] {
		lappend res $tra
	    }
	}
	return $res
    }

    proc empty_list {l} {
	return [expr [string length $l] == 0]
    }

    proc saveOrthography {txt} {
	foreach {t h} [get_orth $txt] {
	    if {$t ne "" && $h ne ""} {
		DicoDAL::writeOrthography $t $h
	    }
	}
    }
    
    proc writeEntry {uid mid id txt} {
    	# save the record.
	set date [TkseshDB::getDate]
	set db [TkseshDB::getTkseshDB]
	set sid [TkseshDB::getSid $db]
	
	DicoDAL::writeEntry $uid $mid $id $date $sid $txt
	
	# Index :
	# We used to do some complex stuff, 
	# comparing old and new stuff...
	# This is most probably not that efficient with a sql engine. Simply :

	set oid [DicoDAL::getLastDicoEntryOID]

	DicoDAL::dropAllIndexesFor $oid

	set newtags [TagHandler::listIndexedTags $txt]

	foreach i $newtags {
	    set tagName [lindex $i 0]
	    set normValue [lindex $i 1]
	    set displayValue [lindex $i 2]
	    # break $i to get the data we need for saveIDX :
	    DicoDAL::saveIDX $tagName $normValue $displayValue $oid
	}

	saveOrthography $txt
	# warn everyone that the dictionnary has changed
	DicoDAL::postEntry
    }
    # End of the functions used for saving the orthography.
    
    # Dictionary loading stuff 
    proc loadOldDicoFile {uid mid txt} {
	foreach {i item} $txt {
	    DicoWF::writeEntry $uid $mid "NULL" $item
	}
    }
    
    # This stuff doesn't belong here.
    proc loaddico {} {
	set fic [tk_getOpenFile  -filetypes {{{dico file} {.dic}} {Any *}}]
	if { "$fic" != "" } {
	    set g [dicogauge]
	    set db [TkseshDB::getTkseshDB]
	    set uid [TkseshDB::getUid $db]
	    set mid [TkseshDB::getMid $db]
	    loadOldDicoFile $uid $mid $fic
	    destroy $g
	}
    }

    variable gauge
    
    proc dicogauge {} {
	variable gauge
	set w .gauge
	toplevel $w
	wm title $w [legendes::trans "Dictionnary loading..."]
	label $w.l -width 40 -textvariable dico::gauge
	pack $w.l
	tkwait visibility $w
	return $w
    }
}
