# Notes Browser. 

# Current organization :

package provide seshDico 0.0
package require myStoopWidgets
package require seshWidget 

class NoteBrowser {
    
    proc NoteBrowser {this name} STopLevel {$name} {
	set ($this,wf) [new NoteBrowserWF $this]
    }
    
    proc ~NoteBrowser {this} {
	delete $($this,wf)
	unset (singleton)
    }

    proc getNoteBrowser {} {
	if {! [info exists (singleton)]} {
	    set (singleton) [Component::buildNewComponent NoteBrowser noteBrowse]
	}
	return $(singleton)
    }
    
    virtual proc completorHook {this} {
	# clear/find/new
	set ($this,operations) \
	    [Component::buildNewComponent SFrame $this -auto]
	set box $($this,operations)
	set ($this,clear) \
	    [Component::buildNewComponent SButton $box -auto  -text "clear"\
		 -command [list NoteBrowser::clearAction $this]]
	set ($this,new) \
	    [Component::buildNewComponent SButton $box -auto  -text "new"\
		 -command [list NoteBrowser::newAction $this]]


	# button box :
	Component::grid [list $($this,clear) $($this,new)] -sticky news
	
	# browser
	set ($this,browser) [Component::buildNewComponent BDBBrowser $this -auto \
				 [NoteBrowserWF::getDataSource $($this,wf)]\
				 {value}]
	
	set ($this,bar) \
	    [Component::buildNewComponent BDBNavigator $this -auto \
		 [NoteBrowserWF::getDataSource $($this,wf)] {1 1 0 0}]

	BDBBrowser::setCommand $($this,browser) [list NoteBrowser::loadCommand $this]
	BDBBrowser::setCaseSensitive $($this,browser) 0
	# Layout for the whole widget :
	Component::grid $($this,operations) -sticky ew
	Component::grid $($this,browser) -sticky news
	Component::grid $($this,bar) -sticky news
	Component::rowConfigure $this 1 -weight 1
	Component::columnConfigure $this 0 -weight 1
    }


    # Create a new dictionnary window using the
    # data in translitteration and translation
    proc newAction {this} {
	set d [buildNewNoteEntry $this]
	DicoTk::setText $d [NoteBrowserWF::buildSimpleEntry $($this,wf)]
    }

    proc clearAction {this} {
	reset $this
    }
    
    proc loadCommand {this idx} {
	set id [NoteBrowserWF::getOIDForID $($this,wf) $idx]
	buildNewNoteEntryForID $this $id
    }
    
    proc buildNewNoteEntry {this} {
	set topName [NoteBrowserWF::getNewTopName $($this,wf)]
	set t [STopLevel::buildNewTopLevel STopLevel $topName]
	set d [Component::buildNewComponent DicoTk $t -auto NOTE]
	Component::grid $d -sticky news
	Component::columnConfigure $t 0 -weight 1
	Component::rowConfigure $t 0 -weight 1
	return $d
    }
    
    proc buildNewNoteEntryForID {this id} {
	set d [buildNewNoteEntry $this]
	DicoTk::load $d $id
    }
}


