# Any graphic element on a CharEditor

class GraphElt {

    proc GraphElt {this window} {
	# Window est la fentre-CharEdit comme objet (son numro)
	set ($this,window) $window
	# Le path associ  ladite fentre
	set ($this,canvas) [Component::getPath $window]
	set ($this,drawing) {}
    }

    proc ~GraphElt {this} {
	# Why did I put this ??? : && $GraphElt::($this,drawing) != "None" 
	if {[info exists GraphElt::($this,drawing)]} {
	    foreach i $GraphElt::($this,drawing)  {
		catch {$GraphElt::($this,canvas) delete $i}
	    }
	}
    }

    virtual proc createDrawing {this};	#  creates the drawing form on the canvas.
    # Sends back the list of id of created data
    # the first one is supposed to be the most important
    
    proc getDrawing {this} {
	return [lindex $GraphElt::($this,drawing) 0]
    }


    # Update is called when the data for an element has changed.
    # Its task is to change the graphical representation
    
    virtual proc update {this} {
	foreach i $GraphElt::($this,drawing) {
	    eval $GraphElt::($this,canvas) coords $i [GraphElt::expandPoints $this]
	}
    }
    
    virtual proc expandPoints {this}

    virtual proc draw {this} {
	# set can $GraphElt::($this,canvas)
     	set GraphElt::($this,drawing) [createDrawing $this]
	# This GraphElt is included in itself.
	tagAsMember $this $this
    }

    # Tag all members of the current GraphElt as members of the $group tagelt.
    # this : element to tag
    # group : container element
    proc tagAsMember {this group} {
	set gTag [allTagName $group]
	foreach i $GraphElt::($this,drawing) {
	    $GraphElt::($this,canvas) addtag  $gTag withtag $i
	}
    }

    # Tag name used for all graphical elements linked to
    # the Contour.
    proc allTagName {this} {
	return "atag$this"
    }

    virtual proc move {this x y}

    virtual proc asText {this};		# sends back a textual representation for the element.

    virtual proc getColor {this} {
	return black
    }

    virtual proc setRed {this} {
	$GraphElt::($this,canvas) itemconfig [getDrawing $this] -fill red
    }

    virtual proc unsetRed {this} {
	set bg [getColor $this]
	$GraphElt::($this,canvas) itemconfig [getDrawing $this] -fill $bg
    }
    
    proc getCharEdit {this} {
	return $($this,window)
    }
}
