class Point {
    proc Point {this x y} {
	set ($this,x) $x 
	set ($this,y) $y
    }
    
    proc ~Point {this} {}

    virtual proc x {this} {return $Point::($this,x)}
    virtual proc y {this} {return $Point::($this,y)}


    proc coords {this} {
	return [list [x $this] [y $this]]
    }

    virtual proc setcoords {this x y} {
	set ($this,x) $x
	set ($this,y) $y	
    }

    proc middle {this m} {
	set x0 [x $this]
	set x1 [x $m]
	set y0 [y $this]
	set y1 [y $m]
	return [new Point [expr ($x0 + $x1) / 2.0] [expr ($y0 + $y1) / 2.0]]
    }

    proc coords3in4 {this a} {
	return [list [expr ([x $this] + 3.0 * [x $a])/ 4] \
		    [expr ([y $this] + 3.0 * [y $a])/ 4]]
    }

    virtual proc double {this orig} {
	set x [expr {[x $orig] + 2 * ([x $this] -  [x $orig])}]
	set y [expr {[y $orig] + 2 * ([y $this] -  [y $orig])}]
	setcoords $this $x $y
    }

    virtual proc asText {this} {
	set c [coords $this]
	return [format {%.4f %.4f} [lindex $c 0] [lindex $c 1]]
    }

    # Interpret a point as a vector. make it normalized.
    proc normalize {this} {
	set d [expr {hypot([x $this],[y $this])}]
	if {$d != 0.0} {
	    setcoords $this [expr {[x $this] / $d}] [expr {[y $this] / $d}]
	}
    }
}

