#
# Essais d'un diteur de fonte
#
# Needs quite a lot of cleaning. But the ideas are sound.
#
# The principles is that coordinates are given by tk canvas,
# so we can use it for all moves (scaling, rotating).
# 
# When an element is changed by the program we call update
# 	Currently, it occurs in proc double {}, because we change one of the lines,
# 	and when a control point is moved, to change the controled items.

#
# GraphElt : graphical element on a CharEdit
# 	window = the font editor
#       createDrawing : creates one or more canvas items
#		and send them back
#	getDrawing : sends back the canvas items number
#	update : change the canvas representation according to new specs.
#	draw : draw the element. Is it of any interest now ????
#	move x y : moves the element by x y
#	asText : the element as a text
#	getColor : the element color
#	setRed 
#	unsetRed

#
# Contour
#
#
# ....
# 
# The next version should be a little cleaner.
# Perhaps we could introduce : atomGraphicElement and Compound GraphicElement
# Another nice move would be to use delegation. That is, there would be
# a line GraphicElement, and all lines would use This element for being drawn
# 

# Nous passons en mode orient objet !!!

#source /stooop-2.3/stooop.tcl
#source /home/serge/TR/TCL/scwoop-1.3/scwoop.tcl

package require stooop 4
namespace import stooop::*
package require myStoopWidgets
package require Sbzr
package require Tksesh
package require BZRFonts
package require seshuser

seshuser::loadOrCreateUser

set tcl_precision 17

##############################################################################
#
#  Realisation effective de l'interface utilisateur
#

# Load Subfiles

foreach i {
    AffineTransformation.tcl
    GraphElt.tcl
    Contour.tcl
    Segment.tcl
    Point.tcl
    ControlPoint.tcl
    ContourControlPoint.tcl
    CharEdit.tcl
    GraphGuide.tcl
    Image.tcl
    LineGuide.tcl
    LineSegment.tcl
    Selection.tcl
    SplineAux.tcl
    Spline.tcl
    utils.tcl
    CharEditToolBar.tcl
    Command.tcl
    FontDisplay.tcl
    CharDBNavigator.tcl
    CharDBValueEditor.tcl
    CharDBWorkflow.tcl
} {
    source [file join $SESHLIB FontEdit $i]
}

# TkseshDB::getTkseshDB

source [file join $SESHLIB FontEdit CharEditAppli.tcl]

# Format des fontes en TCL :
# Un caractere :
# CHAR ::= "{" CODE WIDTH BB CONTOUR* "}"
# BB ::= llx lly urx ury
# CONTOUR ::= "{" TYPEC SENS POINT SEGMENTS* "}"
# TYPEC ::= "CMP" (composite)
# SENS ::= "P" | "N" | "T" | "S"
# SEGMENT ::= "{" TYPESEG POINT* "}"
#
# Un segment : {type points de controle, sauf le premier}
#
# Les codes segments sont l pour ligne et s pour spline
# les codes Contours sont p pour positif n pour negatif
# c pour les lignes de contruction. A noter qu'il est possible de stocker dans une fonte 
# un ensemble de lignes de contruction.
# Les possibilites :
# 
# bzr::new => nouvelle fonte
# bzr::get fonte char
# bzr::set fonte char
# bzr::load fonte nom (charge une fonte nommee nom dans la fonte fonte)
# bzr::save fonte nom (le contraire)


# Compatibility test with : 
#	tksesh "normal" tcl functions : ok
#	BWidget functions : ok
#  package require seshuser
#  seshuser::loaduser
#  puts [seshuser::getvar NAME]
#  #package require BWidget 1.3
#  Label .toto -text "Hello" -helptext "hello text"
#  pack .toto

