#
# normalize translitterations and the like
# 

package provide seshnormalize 0.0

namespace eval seshnormalize {
    namespace export norm_translit unnorm_translit

    # Table for mapping egyptian letters to get correct ordering
    variable alphabet
    variable revalphabet

    array set alphabet {
	A a
	i b
	a c
	w d
	b e
	p f
	f g
	m h
	n i
	r j
	h k
	H l
	x m
	X n
	s o
	S p
	q q 
	k r
	g s
	t t
	T u
	d v
	D w
	l x
    }

    foreach c [array names alphabet] {
	set revalphabet($alphabet($c)) $c
    }

    proc norm_translit {tr} {
	# first, any variant character should be normalized
	regsub -all {[^`3abdfghijklmnwpqrstwxyzADHSTX]} $tr {} tr
	regsub -all j $tr i tr
	regsub -all y $tr ii tr
	regsub -all ` $tr a tr
	regsub -all 3 $tr A tr
	regsub -all z $tr s tr
	
	# second, all chars are mapped to other chars, so that 
	# the text is kept in Egyptian alphabetic order

	variable alphabet
	set res ""
	foreach c [split $tr {}] {
	    append res $alphabet($c)
	}
	return $res
    }
    
    proc unnorm_translit {tr} {
	variable revalphabet
	set res ""
	foreach c [split $tr {}] {
	    append res $revalphabet($c)
	}
	return $res
    }
}
