
package provide tkseshUtils 1.0
package require stooop

# Utility class with static methods.
class TkseshUtils {
    
    proc TkseshUtils {this} {
    }

    proc ~TkseshUtils {this} {
    }
    
    # args -- procedure to process an argument list
    # opts : name of the array that will contain the arguments
    # optlist : list of options and default value e.g. : {-dx 0 -dy 0}
    # args : the arguments to process
    
    proc args {opts optlist arglist} {
	upvar $opts o

	foreach {name value} $optlist {
	    set o($name) $value
	}

	foreach {name value} $arglist {
	    set code [catch {set tmp $o($name)} err]

	    if { $code != 0} {
		tk_dialog  .dialog  [legendes::trans "error"]\
		    [legendes::trans 
		     "A function received an unexpected argument: %s. \
This is a bug, please report" $name] \
		    "" 0 [legendes::trans "Ok"]
	    }
	    set o($name) $value
	}
    }
    
    # TkseshUtils::computeSetDifference --
    #          returns the difference of two sets, represented as lists
    # Arguments:
    #   s1, s2 : lists
    #
    # Results:
    #   s1 - s2, considering s1 and s2 as sets


    proc computeSetDifference {s1 s2} {
	set s1 [uniq $s1]
	set s2 [uniq $s2]
	foreach i $s1 {
	    myIncr tmp($i)
	}
	foreach i $s2 {
	    myIncr tmp($i) -1
	}
	set result [list]
	foreach {i n} [array get tmp] {
	    if {$n > 0} {
		lappend result $i
	    }
	}
	return $result
    }

    proc computeSetIntersection {s1 s2} {
	set s1 [uniq $s1]
	set s2 [uniq $s2]
	foreach i $s1 {
	    myIncr tmp($i)
	}
	foreach i $s2 {
	    myIncr tmp($i)
	}
	set res [list]
	foreach {i n} [array get tmp] {
	    if {$n >= 2} {
		lappend res $i
	    }
	}
	return $res
    }
    
    proc uniq {l} {
	foreach i $l {
	    myIncr  tmp($i)
	}
	return  [array names tmp]
    }

    proc myIncr {var {val 1}} {
	upvar $var x
	if [catch {incr x $val}] {
	    set x 0
	    incr x $val
	}
    }

}

# Interface class for progress meters.
class ProgressMeter {
    proc ProgressMeter {this} {
    }

    proc ~ProgressMeter {this} {
    }

    virtual proc setMax {this max}
    
    virtual proc notify {this value}

    virtual proc notifyFinish {this}
    
    proc callSetMax {pm max} {
	if {$pm} {
	    ProgressMeter::setMax $pm $max
	}
    }

    proc callNotify {pm value} {
	if {$pm} {
	    ProgressMeter::notify $pm $value
	}
    }

    proc callFinish {pm} {
	if {$pm} {
	    ProgressMeter::notifyFinish $pm
	}
    }
}

