
package provide myStoopWidgets 1.0

proc listreplace {l elt {rep {}}} {
    upvar $l list
    set i [lsearch -exact $list $elt]
    if { [string compare $rep {}] == 0} {
	set list [lreplace $list $i $i]	
    } else {
	set list [eval {lreplace $list $i $i} $rep]
    }
}

class Observable {

    proc Observable {this} {
	set ($this,observers) [list]
    }

    proc ~Observable {this} {
	set obs $($this,observers)
	set ($this,observers) [list]
	notify $this deleting
	foreach i $obs {
	    Observer::remove $i $this
	}
    }
    
    proc add {this observer} {
	lappend ($this,observers) $observer
    }

    proc remove {this observer} {
	listreplace ($this,observers) $observer
    }
    
    proc notify {this msg} {
	foreach o $($this,observers) {
	    Observer::update $o $this $msg
	}
    }
}

class Observer {
    
    proc Observer {this} {
	set ($this,observables) [list]
    }
    
    # When an observer is deleted, it should remove itself from all his known observable
    
    proc ~Observer {this} {
	foreach i $($this,observables) {
	    Observable::remove $i $this
	}
    }
    
    # In a perfect world, the next two methods should only be known by
    # Observable. DON'T USE THEM !
    
    proc add {this observable} {
	lappend ($this,observables) $observable
    }
    
    proc remove {this observable} {
	listreplace ($this,observables) $observable
    }
    
    virtual proc update {this observable msg}
}

