#!/bin/sh
# the next line restarts using wish\
exec wish8.0 "$0" "$@"

event add <<Paste>> <Control-y>
event add <<Paste>> <Control-v>
event add <<Paste>> <Button-2>
event add <<Copy>> <Control-c>
event add <<Cut>> <Control-x>

lappend auto_path $env(SESHLIB) \
    [file join $env(SESHLIB) stooop]\
    [file join $env(SESHLIB) scwoop]


package require stooop
namespace import stooop::*

package require legendes

# Ensures the user is defined.
package require seshuser
package require TkseshDB
package require seshDico

seshuser::loadOrCreateUser

package require seshw
#package require dicoload
#package require dico

# Temporary load

source [file join $env(SESHLIB) SQLLoad sqlload.tcl]


# Dictionary initialization
TagHandler::declareAllTags
font create mdctranslitlc -family mdctranslitlc -size 18

###############################################################################
#			      procedure utilitaire pour les variable

proc defaut {var def} {
    upvar $var v
    global env
    if [catch {set v $env($var)}] {
	set v $def
    }
}

set w [seshw::create_editor .w -height 225 -width 600 -show_words true \
	   -linesep 10 \
	   -in_columns 0\
	   -htline 45 ]


source [file join  $env(SESHLIB) fonctions.tcl]
source [file join  $env(SESHLIB) about.tcl]
source [file join  $env(SESHLIB) seshmenus.tcl]

seshw::create_info $w
label .helpbar -textvariable varinfo -justify left

grid $w -sticky news
grid .helpbar -sticky nws

grid rowconfigure . 0 -weight 1
grid columnconfigure . 0 -weight 1

new_text .w

if {$tcl_platform(platform) == "unix"} {
    image create photo icone -file [file join $env(SESHLIB) icons hiboux.gif]
    toplevel .icone
    label .icone.image -image icone
    wm iconwindow . .icone
    wm iconmask . @[file join $env(SESHLIB) icons mask.xbm]
    pack .icone.image
}


# TEST FOR FONT AUTOLOADING SYSTEM :

package require BWidget 1.3

proc loadSign {code} {
    MessageDlg .message -message "unknown sign $code" -icon warning -type ok
}


#tksesh_unknownSignCommand loadSign
