package require tclSQLDB
package require myStoopWidgets

# must be linked to a datasource.
# possibilities are :
# * choise of fonts
# * control/filter from an entry widget.
# * callback used when selecting an entry
# * possibility to fix the position of the first displayed entry
# * possibility to get the current entry (easy, it's the datasource)
# * 

package provide tkDB 1.0

class BDBListBox {

    proc BDBListBox {this parent name dataSource columns args} \
	SimpleComponent {$parent $name $args} \
	Observer {} {
	    puts "we are $this"
	    set ($this,dataSource) $dataSource
	    set ($this,column) $columns
	    PRIVsetFirstIndex $this 0
	    set ($this,lastHeight) -1
	}

    proc ~BDBListBox {this} {
	puts "BDBListBox  $this deleted"
	catch {
	    # Unregister :
	    Observable::remove $($this,dataSource) $this
	    # Delete the auxiliary command (if needed)
	    rename [Component::getPath $this] ""
	    rename [PRIVgetCommandName $this] ""
	}
    }
    
    # The real command name for the tk widget.
    proc PRIVgetCommandName {this} {
	set path [Component::getPath $this]
	return "::..BDB..$path"
    }
    
    # creatorHook's job is to give this widget a path
    virtual proc creatorHook {this} {
	#set options [list -columns $($this,colDecls)]
	set path [Component::getPath $this]
	#eval tablelist::tablelist $path $options [Component::getArgs $this]
	eval listbox $path [Component::getArgs $this] 
	rename ::$path [PRIVgetCommandName $this]
	[PRIVgetCommandName $this] insert end hello
	# Redefine the widget command so that yview uses the OO system :
	set COM {
	    proc ::THEPATH {args} {
		eval BDBListBox::PRIVlistbox THIS $args
	    }
	}
	set COM [string map [list THEPATH $path THIS $this] $COM]
	namespace eval :: $COM
	Observable::add $($this,dataSource) $this
	
	# I had commented these lines. WHY ????????
	#set body [$path bodypath]
	#puts [bind $body <<Button1>>] 
	
	bind $path <Button-1> "BDBListBox::PRIVSelectRow $this %x %y %W"
    }

    proc PRIVlistbox {this args} {
	set path [Component::getPath $this]
	set c [lindex $args 0]
	switch -- $c {
	    yview {
		eval BDBListBox::yview $this [lrange $args 1 end ]
	    }
	    activate {
		BDBListBox::PRIVactivate $this [lindex $args 1]
		eval [PRIVgetCommandName $this] $args			
	    }
	    see {
		eval [PRIVgetCommandName $this] $args
		::update idletasks
	    }
	    configure {
			# separate yscrollcommand and other configuration :
		set conf {}
		foreach {opt com} [lrange $args 1 end] {
		    if {$opt ne "-yscrollcommand"} {
			lappend conf $opt $com
		    } else {
			BDBListBox::setYScrollCommand $this $com
			lappend conf $opt [list BDBListBox::notifyScrollBar $this]
		    }
		}
		if {[llength $conf] != 0} {
		    # Do normal configuration :
		    eval [PRIVgetCommandName $this] configure $conf
		}
	    }
	    default {
		eval [PRIVgetCommandName $this] $args
	    }
	}
    }


    proc PRIVactivate {this idx} {
	set first [BDBListBox::getFirstIndex $this]
	if {! [string match "@*" $idx ]} {
	    set i [expr {$idx + $first}]
	    if {($i < [BDBListBox::getFirstIndex $this])} {
		incr first -1
		BDBListBox::PRIVsetFirstIndex $this $first
		BDBListBox::refresh $this
	    } elseif {($i > [BDBListBox::getLastIndex $this])} {
		incr first 
		BDBListBox::PRIVsetFirstIndex $this $first
		BDBListBox::refresh $this
	    }
	}
    }
    

    proc setCurrent {this idx} {
	PRIVsetFirstIndex $this $idx
	refresh $this
	set p [Component::getPath $this]
	$p selection set 0
    }

    # Completor hook's job is to finish the objet, once the path exists.
    virtual proc completorHook {this} {
	refresh $this
	PRIVRefreshIndex $this
	Component::bind $this <Map> [list BDBListBox::refresh $this]
	Component::bind $this <Configure> [list BDBListBox::refresh $this]
    }

    virtual proc update {this observable msg} {
	puts "listbox doing $msg"
	switch -- $msg {
	    "IndexChanged" {
		PRIVRefreshIndex $this
	    }
	    "ObservableDeleted" {}
	    "dataChanged" -
	    "rowDeleted" {
		refresh $this
		PRIVRefreshIndex $this
	    }
	    "rowChanged" -
	    "rowCreated" {
		refresh $this
	    }
	}
    }

    proc refresh {this} {
	set p [Component::getPath $this]
	set f [$p cget -font]
	set ($this,lineheight) [font metrics $f -linespace]

	set ds $($this,dataSource)
	$p delete 0 end
	# last displayed index
	set last [expr {[getLastIndex $this]}]
	puts "i from [getFirstIndex $this] to $last"
	for {set i [getFirstIndex $this]} {$i <= $last && $i > -1} {incr i} {
	    set line [DataSource::getColIdx $ds $i $($this,column)]
	    $p insert end $line
	}
	set ($this,lastHeight) [getHeight $this]
    }

    proc PRIVRefreshIndex {this} {
	set idx [DataSource::getIndex $($this,dataSource)]
	set p [Component::getPath $this]
	$p activate $idx
	$p selection clear 0 end
	$p selection set $idx
    }


    proc PRIVSelectRow {this x y W} {
	set xx [expr {$x + [winfo x $W]}]
	set yy [expr {$y + [winfo y $W]}]
	set path [Component::getPath $this]
	set row [$path nearest $yy]
	DataSource::doAction $($this,dataSource) setIndex $row
    }

    proc PRIVsetFirstIndex {this idx} {
	if { $idx < 0 } {
	    set idx 0
	} elseif { $idx >= [getSize $this]} {
	    set idx [expr {[getSize $this] -1}]
	}
	set ($this,firstIndex) $idx
    }
    
    proc getFirstIndex {this} {
	return $($this,firstIndex)
    }
    
    proc getHeight {this} {
	set p [Component::getPath $this]
	set l [expr {[winfo height $p]/$($this,lineheight)}]
	return $l
    }

    proc getLastIndex {this} {
	set last [expr {[getFirstIndex $this] + [getHeight $this]}]
	
	if {$last >= [getSize $this]} {
	    set last [expr {[getSize $this] -1}]
	}
	return $last
    }
    
    proc attachScrollBar {this sb} {
	set ($this,scrollbar) $sb
    } 

    proc getSize {this} {
	return [DataSource::getSize $($this,dataSource)]
    }
    
    proc yview {this command args} {
	switch -- $command {
	    moveto {
		if {$args < 0} {set args 0}
		if {$args > 1} {set args 1}
		set first [expr {int($args * ([getSize $this] -1))}]
		PRIVsetFirstIndex $this $first
	    }
	    scroll {
		set ammount [lindex $args 0]
		set unit [lindex $args 1]
		switch -- $unit {
		    units {
			set i [getFirstIndex $this]
			incr i $ammount
		    } 
		    pages {
			set i [getFirstIndex $this]
			set a [expr {[getHeight $this]*$ammount}]
			incr i $a
		    }
		}
		PRIVsetFirstIndex $this $i
	    } 
	}
	refresh $this
	notifyScrollBar $this
    }

    proc getIndex {this} {
	set p [Component::getPath $this]
	set i [$p index active]
	set i [expr {$i + [getFirstIndex $this]}]
	return $i
    }
    
    ## Who calls "pathName set first last" for the scrollbar ?

    proc notifyScrollBar {this {a 0} {b 0}} {
	set s [expr [getSize $this] - 1]
	if {$($this,lastHeight) < [getHeight $this]} {
	    refresh $this
	}
	if {$s < 0} {
	    set s 0
	}
	if {$s != 0} {
	    set f [expr {[getFirstIndex $this] / (1.0 * $s)}]
	    set e [expr {[getLastIndex $this] / (1.0 * $s)}]
	} else {
	    set f 0.0
	    set e 1.0
	}
	eval $($this,yscrollCommand)  $f $e
    }

    
    proc setYScrollCommand {this com} {
	set ($this,yscrollCommand) $com
    } 
}