#!/usr/local/TCL84/bin/wish8.4

set env(SESHLIB) /home/rosmord/Prog/tksesh/tcllib
set SESHLIB $env(SESHLIB)

lappend auto_path $SESHLIB

package require stooop
namespace import stooop::*

package require tclSQLDB
package require tkDB


# Examples of use of datasources
set db [new SQLDB test.db]

#set s [new DataSource $db "select * from students where class = :fixedClass:"]
set s [DataSource::buildTableDataSource $db "students" {studentID} {studentID a name t age i class t}]
# (note the use of "fixedClass". It's not a column name, but a "externalField".

#DataSource::declareColumns $s {studentID i name t age i}

# declare the fields (if any)
#DataSource::declareExternal $s {fixedClass t}

#DataSource::setExternalCol $s fixedClass "1st year"
DataSource::setDefault $s name "xxx"
DataSource::setDefault $s age "30"
DataSource::setValidityTest $s testGood
DataSource::setDeletableTest $s testDelete

# Forbid inscription of Sauron
proc testGood {ds} {
    if {[DataSource::getCol $ds "name"] eq "Sauron"} {
	return 0
    }
    return 1
}

# Forbid deletion of Elrond

proc testDelete {ds} {
    return 1
    if {[DataSource::getCol $ds "name"] eq "Elrond"} {
	return 0
    }
    return 1
}


# validate
DataSource::refresh $s

set classes [DataSource::buildTableDataSource $db "classes" {class} {class t}]
DataSource::setDefault $classes "class" "?"
DataSource::refresh $classes

set t [new STopLevel ""]

#set f1 [new BDBField $t -auto $s "name"]

set t0 [Component::buildNewComponent BDBTableList $t -auto $s {studentID name age class} -activestyle frame -takefocus 1]
set f0 [Component::buildNewComponent BDBField $t -auto $s "studentID"]
set f1 [Component::buildNewComponent BDBField $t -auto $s "name"]
set f2 [Component::buildNewComponent BDBField $t -auto $s "age"]
set f3 [Component::buildNewComponent BDBComboBox $t -auto $s "class" -editable false]

BDBComboBox::setListDataSource $f3 $classes "class"
set nav [Component::buildNewComponent BDBNavigator $t -auto $s]

grid columnconfigure . 0 -weight 1
grid rowconfigure . 0 -weight 1
grid [Component::getPath $t0] -sticky news
grid [Component::getPath $f0] -sticky w
grid [Component::getPath $f1] -sticky w
grid [Component::getPath $f2] -sticky w
grid [Component::getPath $f3] -sticky w
grid [Component::getPath $nav] -sticky ew

set classEdit [Component::buildNewComponent BDBField $t -auto $classes "class"]
set nav1 [Component::buildNewComponent BDBNavigator $t -auto $classes {1 0 0 0}]

grid [Component::getPath $classEdit] -sticky w
grid [Component::getPath $nav1] -sticky ew


#button .next -command [list DataSource::next $s] -text next
#button .previous -command [list DataSource::previous $s] -text previous

#grid .previous .next

# Create fields for editing student studentID, name, age and class.
# (Note that studentID is readOnly)
# Create a navigator
# let's roll !

