#####################################################################
#
# yellow --
# a package to display online help. Some ideas and tricks inspired
# by the WidgetTip package in 
#
#

package provide yellow 0.0

namespace eval yellow {
    namespace export create state
    variable VARS

    set VARS(enabled) 1

    proc create {b text} {
	variable VARS
	set VARS($b,text) $text
	set VARS($b,enabled) 1
	set VARS($b,id) 0
	bind $b <Enter> {yellow::toshow %W}
	bind $b <Leave> {yellow::unshow %W}
	bind $b <Destroy> {yellow::destroy %W}
	bind $b <KeyPress> {yellow::disable %W}
	bind $b <ButtonPress> {yellow::disable %W}
    }

    proc toshow {b} {
	variable VARS
	if {$VARS(enabled)} {
	    set VARS($b,id) [after 1000 [list yellow::show $b ]]
	}
    }

    proc unshow {b} {
	variable VARS
	set VARS($b,enabled) 1
	if {$VARS(enabled)} {
	    after cancel $VARS($b,id)
	}	
    }

    proc disable {b} {
	variable VARS
	set VARS($b,enabled) 0
    }

    proc show {b} {
	variable VARS
	if {$VARS($b,enabled)} {
	    set w $b.helper
	    set x [winfo pointerx $b]
	    set y [winfo pointery $b]
	    incr x -3
	    incr y -3
	    toplevel $w -bg yellow
	    wm geometry $w +$x+$y
	    wm deiconify $w
	    label $w.txt -text $VARS($b,text) -bg yellow
	    pack $w.txt
	    wm overrideredirect $w 1
	    bind $w <Leave> {destroy %W}
	}
    }

    proc destroy {b} {
	variable VARS
	unshow $b
	unset VARS($b,id)
	unset VARS($b,text)
    }

    proc state {args} {
	variable VARS
	if {[llength $args] == 0} {
	    return $VARS(enabled)
	} else {
	    set VARS(enabled) [lindex $args 0]
	}
    }
}